// DataBasePage.cpp : implementation file
//

#include "stdafx.h"
//#include "YtvUltraSoundMedScan0.h"
#include "DataBasePage.h"
#include "NewEditPatientDial.h"
#include "PatientHistoryDial.h"
#include "NewEditLensDial.h"
#include "Editdoctor.h"
#include "YtvEmailDial.h"
#include "YtvImportExportDial.h"
#include "YtvScansDoc.h"
#include "YtvScansView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DataBasePage property page
extern int g_nRow;
extern CString g_szPatientId;
extern BOOL g_bNewPatient;
extern BOOL g_bPatient;
BOOL Some ;
int g_nMETHOD1Calc=1;   
entypeRegistryNodes DataBasePage::m_enTypeRegNode=encCommonSettings;
char* DataBasePage::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* DataBasePage::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* DataBasePage::m_pszDoctorRecFormat[]=    {"DoctorID","FirstName","LastName","Nt",NULL};
char* DataBasePage::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* DataBasePage::m_pszLensTypeRecFormat[]=       {"LensMfg", "LensName","MfgA_Const","MfgACD","MfgSF","Hacd",NULL};
char* DataBasePage::m_pszFullLensTypeRecFormat[]=   {"LensMfg", "LensName","MfgA_Const","pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* DataBasePage::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const","MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
struct sttypeRegistryNodes DataBasePage::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL}

};
IMPLEMENT_DYNCREATE(DataBasePage, CPropertyPage)

DataBasePage::DataBasePage() : CPropertyPage(DataBasePage::IDD)
{
	//{{AFX_DATA_INIT(DataBasePage)
	m_nSearch = 0;
	m_edSearch = _T("");
	m_nCalculator = g_nMETHOD1Calc;
	m_nPatientDoctorEtc = 0;
	m_szDBName = _T("Untitled");
	//}}AFX_DATA_INIT
	m_nPrevSection=0;
	m_nEditNewDel=0;	
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,255,255); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(0,0,255);
	m_clrButtonsFront=RGB(255,0,255);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,255); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,255);
	m_clrEditBoxesFront=RGB(0,0,0);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
	m_hfntButtons=0;
	m_comboComPort.Empty();
	for(int i=0; i<MaxNumbFieldsInDbPatientRec;i++)
            m_pszDbPatientRec[i]="";
	for(i=0; i<MaxNumbFieldsInDbDoctorRec;i++)
            m_pszDbDoctorRec[i]="";
	for(i=0; i<MaxNumbFieldsInDbLensStyleRec;i++)
            m_pszDbLensStyleRec[i]="";	
	m_arListReg[encLensTypeRec].Data=m_pszDbLensStyleRec;
	m_arListReg[encPatientTypeRec].Data=m_pszDbPatientRec;
	m_arListReg[encDoctorTypeRec].Data=m_pszDbDoctorRec;
	m_pPSh=NULL;
	m_pPPg=NULL;
	g_szPatientId.Empty();
	m_pView=NULL;
}

DataBasePage::~DataBasePage()
{
	DeleteObject(m_hfntButtons);

}

void DataBasePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DataBasePage)
	DDX_Control(pDX, IDC_DB_NAME, m_stDB_NAME);
	DDX_Control(pDX, IDC_BYPATIENTID, m_comboS0);
	DDX_Control(pDX, IDC_BYFIRSTNAME, m_comboS1);
	DDX_Control(pDX, IDC_BYLASTNAME, m_comboS2);
	DDX_Control(pDX, IDC_EDIT_TABLES, m_tabEditTables);
	DDX_Control(pDX, IDC_INPUT_OUTPUT, m_tabInputOutput);
	DDX_Radio(pDX, IDC_BYPATIENTID, m_nSearch);
	DDX_Text(pDX, IDC_EDSEARCH, m_edSearch);
	DDX_Radio(pDX, IDC_METHOD1_CALCULATOR, m_nCalculator);
	DDX_Radio(pDX, IDC_PATIENT, m_nPatientDoctorEtc);
	DDX_Control(pDX, IDC_TABLES, m_gridTables);
	DDX_Text(pDX, IDC_DB_NAME, m_szDBName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DataBasePage, CPropertyPage)
	//{{AFX_MSG_MAP(DataBasePage)
	ON_BN_CLICKED(IDC_PATIENT, OnPatient)
	ON_BN_CLICKED(IDC_LENS_STYLES, OnLensStyles)
	ON_BN_CLICKED(IDC_DOCTOR, OnDoctor)
	ON_NOTIFY(NM_CLICK, IDC_INPUT_OUTPUT, OnClickInputOutput)
	ON_NOTIFY(TCN_SELCHANGE, IDC_INPUT_OUTPUT, OnSelchangeInputOutput)
	ON_NOTIFY(TCN_SELCHANGE, IDC_EDIT_TABLES, OnSelchangeEditTables)
	ON_NOTIFY(NM_CLICK, IDC_EDIT_TABLES, OnClickEditTables)
	ON_WM_CTLCOLOR()
	ON_COMMAND(IDM_FONT, OnFont)
	ON_UPDATE_COMMAND_UI(IDM_FONT, OnUpdateFont)
	ON_BN_CLICKED(IDC_SEARCHBUTTON, OnSearchbutton)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_METHOD1_CALC, OnMETHOD1Calc)
	ON_BN_CLICKED(IDC_METHOD1_CALCULATOR, OnMETHOD1Calculator)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_DB, OnButtonOpenDb)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_DB_AS, OnButtonSaveDbAs)
	ON_BN_CLICKED(IDC_DB_NAME, OnDbName)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_APP, OnButtonCloseApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////// Registry/DB processing ////////////////////////
int DataBasePage::FindRecord(const char* RecordId, DWORD column)
{
   int i=m_gridTables.GetRows(),j,res;
   CString Temp;
   if(i==0)
	   return -2;
   for(j=0;j<i;j++)
   {
      Temp=m_gridTables.GetTextMatrix(j,column); 
	  res=strcmp(Temp,RecordId);
	  if(res==0)
		  return j;
   }
   return -1;

}
int DataBasePage::FindLastRecord(DWORD column)
{
   int i=m_gridTables.GetRows(),j;
   CString Temp;
   if(i==0)
	   return -2;
   for(j=0;j<i;j++)
   {
      Temp=m_gridTables.GetTextMatrix(j,column); 
	  if(Temp.IsEmpty())
		  return j;
   }
   return -1;
}
BOOL DataBasePage::WriteRegistryDB(const char* RecordId)
{
	int NumbRecord,j,NumbCol;
	CString Temp0,Temp1;
	char *pf;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return FALSE;  
    pf=m_arListReg[m_enTypeRegNode].Format[0];
	if(pf==NULL)
		return FALSE;
	NumbRecord=FindRecord(RecordId);
	if(NumbRecord<0)
               NumbRecord=FindLastRecord();
	if(NumbRecord>=0)
    {   
		NumbCol=m_gridTables.GetCols();
		YtvWriteProfileString(RecordId,pf,RecordId,1);
        Temp0=pf;
		if(1<NumbCol)
              m_gridTables.SetTextMatrix(NumbRecord,1,RecordId);
		for(j=1;;j++)
        {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
		   Temp1=m_arListReg[m_enTypeRegNode].Data[j];
           YtvWriteProfileString(RecordId,pf,Temp1,1); 
		   if(j<NumbCol)
              m_gridTables.SetTextMatrix(NumbRecord,j,Temp1);
        }
    }
	return TRUE;
}
void DataBasePage::RemoveAll()
{
  //UpdateData();
  int i,ii,cols=m_gridTables.GetCols(),rows=m_gridTables.GetRows();
  for(i=0; i<cols;i++)
     for(ii=1;ii<rows;ii++) 
		 m_gridTables.SetTextMatrix(ii,i,"");
  //UpdateData(FALSE);

}
int DataBasePage::ReadRegistryDB()
{
	int NumbRecords=0,i,j;
	CString Temp0,Temp1,Temp;
	char* pch,*pf,*pchtemp;
	RemoveAll();
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return NumbRecords;
    int numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,NULL,0);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(m_arListReg[m_enTypeRegNode].Node,pch,numbchar+1);
	if(numbchar==0)
	{
		delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	for(i=1;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
    {
       m_gridTables.SetTextMatrix(i,0,pchtemp);      
    }
    NumbRecords=i-1;
	delete []pch;
    for(i=1;i<=NumbRecords;i++)
    {
        Temp0=m_gridTables.GetTextMatrix(i,0);
		for(j=1;;j++)
        {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
           Temp1=YtvGetProfileString(Temp0,pf,"",1);
           m_gridTables.SetTextMatrix(i,j,Temp1);
        }
    }
    if(NumbRecords>0 && g_szPatientId.IsEmpty() && g_bPatient==TRUE)
    {
		Temp=m_gridTables.GetTextMatrix(1,0);
		g_szPatientId=Temp;
		g_bNewPatient=TRUE;
	    g_bPatient=TRUE;
		g_nRow=1;
		m_gridTables.SetRow(1);
		m_gridTables.SetRowSel(1);
    }
	else if(NumbRecords>0 && g_bPatient==TRUE)
    {
		 int cols=m_gridTables.GetRows();
		 for(int i=1; i<cols; i++)
		 {
            	Temp=m_gridTables.GetTextMatrix(i,0);
				if(Temp.IsEmpty())
					break;
				if(g_szPatientId!=Temp)
					continue;
                g_nRow=i;
				m_gridTables.SetRow(i);
                m_gridTables.SetRowSel(i);
				if(!m_gridTables.GetRowIsVisible(i))
				     m_gridTables.SetTopRow(i-17);                
				break;
         }
         
    }
	UpdateData(FALSE);
	return NumbRecords;
}
/////////////////////////////////////////////////////////////////////////////
// DataBasePage message handlers

void DataBasePage::OnPatient() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);  
	CString Temp;
	m_nPrevSection=m_nPatientDoctorEtc;
	m_tabEditTables.DeleteAllItems();
	m_tabEditTables.InsertItem(0,"Current Database");
	m_tabEditTables.InsertItem(1,"Add New Patient");
    m_tabEditTables.InsertItem(2,"Edit Patient");
	m_tabEditTables.InsertItem(3,"Delete Patient");
	m_tabEditTables.InsertItem(4,"Patient History");
    ///////////////////////////////////////////////////
/*	m_gridTables.SetRows(2000);
	m_gridTables.SetCols(5);
	m_gridTables.SetFixedCols(0);
	m_gridTables.SetTextMatrix(0, 0, "Patient ID");   
    m_gridTables.SetTextMatrix(0, 1, "First Name");
	m_gridTables.SetTextMatrix(0, 2, "Last Name");
	m_gridTables.SetTextMatrix(0, 3, "Doctofr's Name");
	m_gridTables.SetTextMatrix(0, 4, "Notes");
	m_gridTables.SetColWidth(0,1260);
	m_gridTables.SetColWidth(1,1700);
	m_gridTables.SetColWidth(2,1700);
	m_gridTables.SetColWidth(3,1700);
	m_gridTables.SetColWidth(4,1700);*/
	m_gridTables.SetRows(2000);
	m_gridTables.SetCols(5);
	m_gridTables.SetFixedCols(0);
	//m_gridTables.SetTextMatrix(0, 0, "No");  
	//YTV Moishe wanted to delete the Number column
	m_gridTables.SetTextMatrix(0, 0, "Patient ID");   
    m_gridTables.SetTextMatrix(0, 1, "First Name");
	m_gridTables.SetTextMatrix(0, 2, "Last Name");
	m_comboS0.SetWindowText(m_gridTables.GetTextMatrix(0, 0));
	m_comboS1.SetWindowText(m_gridTables.GetTextMatrix(0, 1));
	m_comboS2.SetWindowText(m_gridTables.GetTextMatrix(0, 2));
	m_gridTables.SetTextMatrix(0, 3, "Doctor's Name");
	m_gridTables.SetTextMatrix(0, 4, "Notes");
	//m_gridTables.SetColWidth(0,430);
	m_gridTables.SetColWidth(0,1260);
	m_gridTables.SetColWidth(1,1600);
	m_gridTables.SetColWidth(2,1600);
	m_gridTables.SetColWidth(3,1600);
	m_gridTables.SetColWidth(4,1600);
	m_enTypeRegNode=encPatientTypeRec;
    YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	ReadRegistryDB();
	if(g_nRow>0)
    {
	   Temp=m_gridTables.GetTextMatrix(g_nRow,0);
	   if(g_szPatientId!=Temp)
	   {
		g_szPatientId=Temp;
		g_bNewPatient=TRUE;
	   }
    }
	g_bPatient=TRUE;
	m_gridTables.SetRow(g_nRow);
	m_gridTables.SetCol(0);
	m_gridTables.SetColSel(m_gridTables.GetCols()-1);
}

void DataBasePage::OnLensStyles() 
{
	// TODO: Add your control notification handler code here
	g_bPatient=FALSE;
	UpdateData(TRUE);
	
	m_nPrevSection=m_nPatientDoctorEtc;
	m_tabEditTables.DeleteAllItems();
	m_tabEditTables.InsertItem(0,"Current Database");
	m_tabEditTables.InsertItem(1,"Add New Lens");
    m_tabEditTables.InsertItem(2,"Edit Lens");
	m_tabEditTables.InsertItem(3,"Delete Lens");
    ///////////////////////////////////////////////////
	m_gridTables.SetRows(2000);
	m_gridTables.SetCols(6);
	m_gridTables.SetFixedCols(0);
	m_gridTables.SetTextMatrix(0, 0, "Lens Mfg");   
    m_gridTables.SetTextMatrix(0, 1, "Lens Name");
	m_gridTables.SetTextMatrix(0, 2, "Mfg A-Const");
	m_gridTables.SetTextMatrix(0, 3, "Mfg ACD");
	m_gridTables.SetTextMatrix(0, 4, "Mfg SF");
	m_gridTables.SetTextMatrix(0, 5, "METHOD1 ACD");
	m_comboS0.SetWindowText(m_gridTables.GetTextMatrix(0, 0));
	m_comboS1.SetWindowText(m_gridTables.GetTextMatrix(0, 1));
	m_comboS2.SetWindowText(m_gridTables.GetTextMatrix(0, 2));
	m_gridTables.SetColWidth(0,1355);
	m_gridTables.SetColWidth(1,1345);
	m_gridTables.SetColWidth(2,1345);
	m_gridTables.SetColWidth(3,1345);
	m_gridTables.SetColWidth(4,1345);
	m_gridTables.SetColWidth(5,1345);
	m_enTypeRegNode=encLensTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	m_gridTables.SetRow(1);
	m_gridTables.SetCol(0);
	m_gridTables.SetColSel(m_gridTables.GetCols()-1);
	ReadRegistryDB();
}

void DataBasePage::OnDoctor() 
{
	// TODO: Add your control notification handler code here
	g_bPatient=FALSE;
	UpdateData(TRUE);
	
	m_nPrevSection=m_nPatientDoctorEtc;
	m_tabEditTables.DeleteAllItems();
	m_tabEditTables.InsertItem(0,"Current Database");
	m_tabEditTables.InsertItem(1,"Add New Doctor");
    m_tabEditTables.InsertItem(2,"Edit Doctor");
	m_tabEditTables.InsertItem(3,"Delete Doctor");
	m_tabEditTables.DeleteItem(4);
    ///////////////////////////////////////////////////
	m_gridTables.SetRows(2000);
	m_gridTables.SetCols(4);
	m_gridTables.SetFixedCols(0);
	m_gridTables.SetTextMatrix(0, 0, "Doctor ID");   
    m_gridTables.SetTextMatrix(0, 1, "First Name");
	m_gridTables.SetTextMatrix(0, 2, "Last Name");
	m_gridTables.SetTextMatrix(0, 3, "Notes");
	m_comboS0.SetWindowText(m_gridTables.GetTextMatrix(0, 0));
	m_comboS1.SetWindowText(m_gridTables.GetTextMatrix(0, 1));
	m_comboS2.SetWindowText(m_gridTables.GetTextMatrix(0, 2));
	m_gridTables.SetColWidth(0,2020);
	m_gridTables.SetColWidth(1,2020);
	m_gridTables.SetColWidth(2,2020);
	m_gridTables.SetColWidth(3,2025);
    m_enTypeRegNode=encDoctorTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	m_gridTables.SetRow(1);
	m_gridTables.SetCol(0);
	m_gridTables.SetColSel(m_gridTables.GetCols()-1);
	ReadRegistryDB();
}



void DataBasePage::OnClickInputOutput(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

void DataBasePage::OnSelchangeInputOutput(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	*pResult = 0;
	int row;
	CString Caption,Id;
	YtvImportExportDial* pdlg;
	YtvEmailDial* pdlgm;	
	row=m_gridTables.GetRowSel();
	if(row<1)
	{
		m_tabInputOutput.SetCurSel(-1);
		return;
    }
	m_nSelInputOutput=m_tabInputOutput.GetCurSel();
	Id=m_gridTables.GetTextMatrix(row,0);
	switch(m_nPatientDoctorEtc)
    {
	default:
		m_tabInputOutput.SetCurSel(-1);
		return;
    case 0:
        Caption="Patient ";
        if(m_nSelInputOutput!=0)
		      Caption+=m_gridTables.GetTextMatrix(row,1)+' '+m_gridTables.GetTextMatrix(row,2);
		break;
    case 1:
        Caption="Doctor ";
        if(m_nSelInputOutput!=0)
		    Caption+=m_gridTables.GetTextMatrix(row,1)+' '+m_gridTables.GetTextMatrix(row,2);
		break;
    case 3:
        Caption="Lens "; 
        if(m_nSelInputOutput!=0)
		    Caption+=m_gridTables.GetTextMatrix(row,0)+' '+m_gridTables.GetTextMatrix(row,1);
		break;
    }
    CString szFile;
    //CFileDialog dlge(TRUE,NULL,"A:\\");
	CFileDialog dlge(TRUE);
	int res;
	switch(m_nSelInputOutput)
    {
    default:
		return;
    case 0://import
       Caption="Import "+Caption;
	   dlge.m_ofn.lpstrTitle=Caption;
       if(dlge.DoModal()==IDCANCEL)
          return;
	   szFile=dlge.GetPathName();
       res=YtvGetProfileReg(Id, szFile, 1);
      	break;
    case 1://export
        pdlg=new YtvImportExportDial;
        pdlg->m_ntype=m_nPatientDoctorEtc;
	    pdlg->m_szId=Id;
        pdlg->m_bExport=TRUE;
        pdlg->m_szInpOutCaption="Export: ";
		pdlg->m_szInpOutCaption+=Caption;
		if(!pdlg->Create(m_hWnd))
		{
			delete pdlg;
			break;
        }
		break;
    case 2://mail to    
		pdlgm=new YtvEmailDial;
        pdlgm->m_szInpOutCaption=Caption;
        pdlgm->m_szId=g_szPatientId;
		if(!pdlgm->Create(m_hWnd))
		{
			delete pdlgm;
			break;  
		}	
		break;
    }
	m_tabInputOutput.SetCurSel(-1);
}
void DataBasePage::NewEditPatient(BOOL bNew)
{
    NewEditPatientDial* dlg=new NewEditPatientDial;
	dlg->m_bEdit=bNew?FALSE:TRUE;
	UpdateData(TRUE);
	if(dlg->m_bEdit)
    {
        int row=m_gridTables.GetRowSel();
	    if(row<1)
		     return;  
		dlg->m_szFirstname=m_gridTables.GetTextMatrix(row,1);
		dlg->m_szPatient_Id=m_gridTables.GetTextMatrix(row,0);
		dlg->m_szLastname=m_gridTables.GetTextMatrix(row,2);
		dlg->m_szNote=m_gridTables.GetTextMatrix(row,4);
		dlg->m_szDoctorName=m_gridTables.GetTextMatrix(row,3);
		//dlg->m_bCallMeasurePage=TRUE;
    }
	m_strAddionalRegistryOld=YtvGetAdditionalRegNode();
    if(!dlg->Create(m_hWnd))
	{
		YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
		UpdateData(FALSE);
		delete dlg;
		return;
    }
/*	YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
	ReadRegistryDB();
	UpdateData(FALSE);
	if(dlg->m_bCallMeasurePage==FALSE || m_pPSh==NULL || m_pPPg==NULL)
	{
		delete dlg;
		return;
    }
    m_pPSh->SetActivePage(m_pPPg);*/
	//LRESULT res=QuerySiblings(encDataBasePage,encMeasurePage);
    //PSM_QUERYSIBLINGS 
}
void DataBasePage::NewEditDoctor()
{
	m_strAddionalRegistryOld=YtvGetAdditionalRegNode();
    Editdoctor* dlg=new Editdoctor;
	dlg->m_szDoctorId.Empty();
	dlg->m_szDFirstName.Empty();
	dlg->m_szDLastName.Empty();
    dlg->m_szNote.Empty();
	if(!dlg->Create(this))
	{
		YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
		UpdateData(FALSE);
		delete dlg;
		return;
    }


}

void DataBasePage::MemEditdoctor()
{
	
	UpdateData(TRUE);
    int row=m_gridTables.GetRowSel();
	if(row<1)
		return;   
	m_strAddionalRegistryOld=YtvGetAdditionalRegNode();
    Editdoctor* dlg=new Editdoctor;
	dlg->m_szDoctorId=m_gridTables.GetTextMatrix(row,0);
	if(dlg->m_szDoctorId.IsEmpty())
	{
		delete dlg;
		return;
    }
	dlg->m_szDFirstName=m_gridTables.GetTextMatrix(row,1);;
	dlg->m_szDLastName=m_gridTables.GetTextMatrix(row,2);
    dlg->m_szNote=m_gridTables.GetTextMatrix(row,3);
	if(!dlg->Create(this))
	{
		YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
		UpdateData(FALSE);
		delete dlg;
		return;
    }
 /*   YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
	ReadRegistryDB();
	UpdateData(FALSE);*/

}
void DataBasePage::NewEditLens(BOOL bNew)
{
    NewEditLensDial* dlg=new NewEditLensDial;
	if(!dlg)
		return;
	dlg->m_bEdit=bNew?FALSE:TRUE;
	UpdateData(TRUE);
	m_strAddionalRegistryOld=YtvGetAdditionalRegNode();
    if(dlg->m_bEdit)
    {
        int row=m_gridTables.GetRowSel();
	    if(row<1)
		{
			delete dlg;
			return;  
        }
//"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF","Hacd"
		dlg->m_szLensemfg=m_gridTables.GetTextMatrix(row,0);
		dlg->m_szLansename=m_gridTables.GetTextMatrix(row,1);
		dlg->m_szMfg_a_const=m_gridTables.GetTextMatrix(row,2);
		dlg->m_szMfg_acd=m_gridTables.GetTextMatrix(row,3);
		dlg->m_szMfg_sf=m_gridTables.GetTextMatrix(row,4);
		dlg->m_szMETHOD1_acd=m_gridTables.GetTextMatrix(row,5);		
    }
    if(!dlg->Create(this))
	//if(!dlg->Create(NULL))
	{
		YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
		UpdateData(FALSE);
		delete dlg;
		return;
    }
/*	YtvSetAdditionalRegNode(m_strAddionalRegistryOld);
	ReadRegistryDB();
	UpdateData(FALSE);*/

}
void DataBasePage::OnSelchangeEditTables(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	PatientHistoryDial* dlg=NULL;
	UpdateData(TRUE);
	*pResult = 0;
	BOOL b;
	int row;
	CString IdKey;
	m_nEditNewDel=m_tabEditTables.GetCurSel();
	switch(m_nPatientDoctorEtc)
    {
    default:
		return;
		////////////////////////////////////
	case 0:
      switch(m_nEditNewDel)
      {
	  default:
      case 0:
		  break;
      case 1:
          NewEditPatient(TRUE);
	      break;
	  case 2:
         NewEditPatient(FALSE);
		 break;         
	  case 3:
		  //delete patient
		  row=m_gridTables.GetRowSel();
		  if(row<1)
			  break;
          IdKey=m_gridTables.GetTextMatrix(row,0);
          g_nRow=-1;
          g_szPatientId.Empty();
          g_bPatient=TRUE;
		  b=YtvDeleteProfileSection(IdKey,1);
		  RemoveGridRow(row);
          break;
      case 4:
          row=m_gridTables.GetRowSel();
	      if(row<1)
		     break; 
		  m_strAddionalRegistryOld=YtvGetAdditionalRegNode();
		  dlg=new PatientHistoryDial;
		  dlg->m_stPatientId=m_gridTables.GetTextMatrix(row,0);
          dlg->m_stPatientName=m_gridTables.GetTextMatrix(row,1)+' '+m_gridTables.GetTextMatrix(row,2);
		  dlg->m_stDoctorName=m_gridTables.GetTextMatrix(row,3);
		  if(!dlg->Create(this))
		  {
			  delete dlg;
			  break; 
          }
		  m_nEditNewDel=0;
	      m_tabEditTables.SetCurSel(m_nEditNewDel);
		  return;
		  break;
      }
	  break;
	  ////////////////////////////////////
	  case 1:
	  switch(m_nEditNewDel)
      {
	  default:
      case 0:
		  break;
      case 1:
          NewEditDoctor();
	      break;
	  case 2:
          MemEditdoctor();
 		 break;         
	  case 3:
		  row=m_gridTables.GetRowSel();
		  if(row<1)
			  break;
          IdKey=m_gridTables.GetTextMatrix(row,0);
		  b=YtvDeleteProfileSection(IdKey,1);
		  RemoveGridRow(row);
		  break;
		  }
      break;
	  //////////////////////////////////////////////
    case 3:
      break;
	  ///////////////////////////////////
    case 2:
      switch(m_nEditNewDel)
      {
	  default:
      case 0:
		  break;
      case 1:
          NewEditLens(TRUE);
	      break;
	  case 2:
         NewEditLens(FALSE);
		 break;         
	  case 3:
		  row=m_gridTables.GetRowSel();
		  if(row<1)
			  break;
          IdKey=m_gridTables.GetTextMatrix(row,0);
		  b=YtvDeleteProfileSection(IdKey,1);
		  RemoveGridRow(row);
		  break;
	  }	 	 
	  break;      
	}
	m_nEditNewDel=0;
	m_tabEditTables.SetCurSel(m_nEditNewDel);

}
void DataBasePage::RemoveGridRow(int rowar)
{
	 int row,i,ii,rows,cols;
	 CString Temp;
     if(rowar<0)
     {
         row=m_gridTables.GetRowSel();
		 if(row<1)
			  return;
     }
	 else
		 row=rowar;
	 row++;
	 rows=m_gridTables.GetRows();
	 cols=m_gridTables.GetCols();
	 for(i=row;i<rows;i++)
       for(ii=0;ii<cols;ii++)
          m_gridTables.SetTextMatrix(i-1,ii,m_gridTables.GetTextMatrix(i,ii));
     rows--;
	 for(ii=0;ii<cols;ii++)
          m_gridTables.SetTextMatrix(rows,ii,"");
}
void DataBasePage::OnClickEditTables(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

HBRUSH DataBasePage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	//HBRUSH hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	
    switch(nCtlColor)
	{
		default:
			return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
			
		case CTLCOLOR_BTN: //  Button control
		            
            return m_hbrButtonsBrush;						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
        case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
	        SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	return CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);
}

BOOL DataBasePage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();	
	CString Temp;
	// TODO: Add extra initialization here
  //  m_tabInputOutput.InsertItem(0,"No I/O");
	m_tabInputOutput.InsertItem(0,"Import");
	m_tabInputOutput.InsertItem(1,"Export to Floppy Disk");
    m_tabInputOutput.InsertItem(2,"Send E-Mail");
	/////////////////////////////////////////////
	m_tabEditTables.InsertItem(0,"Current Database");
	m_tabEditTables.InsertItem(1,"Add New Patient");
    m_tabEditTables.InsertItem(2,"Edit Patient");
	m_tabEditTables.InsertItem(3,"Delete Patient");
	m_tabEditTables.InsertItem(4,"Patient History");
    ///////////////////////////////////////////////////
	m_gridTables.SetRows(2000);
	m_gridTables.SetCols(6);
	m_gridTables.SetFixedCols(0);
	m_gridTables.SetTextMatrix(0, 0, "No");  
	m_gridTables.SetTextMatrix(0, 1, "Patient ID");   
    m_gridTables.SetTextMatrix(0, 2, "First Name");
	m_gridTables.SetTextMatrix(0, 3, "Last Name");
	m_gridTables.SetTextMatrix(0, 4, "Doctor's Name");
	m_gridTables.SetTextMatrix(0, 5, "Notes");
	m_gridTables.SetColWidth(0,430);
	m_gridTables.SetColWidth(1,1260);
	m_gridTables.SetColWidth(2,1600);
	m_gridTables.SetColWidth(3,1600);
	m_gridTables.SetColWidth(4,1600);
	m_gridTables.SetColWidth(5,1600);
    m_enTypeRegNode=encCommonSettings;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	ReadRegistryDB();
	if(g_nRow<=0)
    {
       g_nRow=0;      
    }
	int rows=m_gridTables.GetRows();
	for(int i=1; i<rows;i++)
	{
		Temp=m_gridTables.GetTextMatrix(i,0);
		if(Temp.IsEmpty())
			break;
    }
	if(g_nRow>=i)
		g_nRow=1;
	if(i==1)
    {
       g_szPatientId.Empty();
       g_bPatient=TRUE;
	   g_bNewPatient=TRUE;
	   g_nRow=0;
    }
	else
    {
	  if(g_nRow)
	  {
       Temp=m_gridTables.GetTextMatrix(g_nRow,0);
	   if(g_szPatientId!=Temp)
	   {
		g_szPatientId=Temp;
		g_bNewPatient=TRUE;
	   }
	  }       
      g_bPatient=TRUE;
    }
	m_gridTables.SetRow(g_nRow);
    m_gridTables.SetCol(0);
    m_gridTables.SetColSel(m_gridTables.GetCols()-1);
	OnPatient();
	m_tabInputOutput.SetCurSel(-1);
	AfxGetMainWnd()->GetWindowText(Temp);
	m_szDBName=Temp;
	m_stDB_NAME.SetWindowText(m_szDBName);  
    return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void DataBasePage::OnFont() 
{
	// TODO: Add your command handler code here
	CFontDialog dlg;
    LOGFONT lf;
    if(dlg.DoModal()==IDCANCEL)
		return; //Displays the dialog and allows the user to make a selection. 
    dlg.GetCurrentFont(&lf);
	m_hfntButtons=CreateFontIndirect(&lf);
 
	//Retrieves the name of the currently selected font. 
/*dlg.GetFaceName(); //Returns the face name of the selected font. 
dlg.GetStyleName //Returns the style name of the selected font. 
dlg.GetSize //Returns the point size of the selected font. 
dlg.GetColor //Returns the color of the selected font. 
dlg.GetWeight //Returns the weight of the selected font. 
dlg.IsStrikeOut //Determines whether the font is displayed with strikeout. 
dlg.IsUnderline //Determines whether the font is underlined. 
dlg.IsBold //Determines whether the font is bold. 
dlg.IsItalic */

}

void DataBasePage::OnUpdateFont(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

BEGIN_EVENTSINK_MAP(DataBasePage, CPropertyPage)
    //{{AFX_EVENTSINK_MAP(DataBasePage)
	ON_EVENT(DataBasePage, IDC_TABLES, 69 /* SelChange */, OnSelChangeTables, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void DataBasePage::OnSelChangeTables() 
{
	// TODO: Add your control notification handler code here
	if(g_bPatient==FALSE)
		return;
	UpdateData();
	int row=m_gridTables.GetRowSel();
	if(row<=0 || row>=m_gridTables.GetRows())
      return;
	CString Temp=m_gridTables.GetTextMatrix(row,0);
	if(Temp.IsEmpty())
		return;
	if(row>0)
    {
       g_nRow=row;
	   if(g_szPatientId!=Temp)
	   {
		g_szPatientId=Temp;
		g_bNewPatient=TRUE;
	   }	   
    }

}
void DataBasePage::OnSearchbutton() 
{
	// TODO: Add your control notification handler code here
	int rows=m_gridTables.GetRows(),r,cols=m_gridTables.GetCols()-1;
	UpdateData();
	CString Temp;
    m_edSearch.TrimLeft();
	m_edSearch.TrimRight();
    //sr=m_gridTables.GetRowSel();
    //m_gridTables.SetRowSel(sr);
	for(r=1;r<rows;r++)
	{
		Temp=m_gridTables.GetTextMatrix(r, m_nSearch);
		Temp.TrimLeft();
		Temp.TrimRight();
		if(Temp==m_edSearch)
        {
			//m_gridTables.SetRowVisible(r);
            UpdateData();
            m_gridTables.SetRow(r);
			m_gridTables.SetCol(0);
            m_gridTables.SetColSel(cols);
            m_gridTables.SetTopRow(r);
            break;
        }
    }
}

BOOL DataBasePage::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	CString Temp;
	int row=m_gridTables.GetRowSel();
	if(row<=0)
    {
       row=1;      
    }
	int rows=m_gridTables.GetRows();	
	for(int i=1; i<rows;i++)
	{
		Temp=m_gridTables.GetTextMatrix(i,0);
		if(Temp.IsEmpty())
			break;
    }
	if(row>=i)
		row=i-1;
	if(row<=0)
    {
       row=0;
    }
	else
    {
       
    }
	m_gridTables.SetRow(row);
    m_gridTables.SetCol(0);
    m_gridTables.SetColSel(m_gridTables.GetCols()-1);
	//Sleep(1000);
	AfxGetMainWnd()->GetWindowText(Temp);
	m_szDBName=Temp;
	m_stDB_NAME.SetWindowText(m_szDBName);  
	if(m_pView)
	{
	   m_szDBName=m_pView->GetDocument()->GetTitle();
	   m_stDB_NAME.SetWindowText(m_szDBName); 
	}   
	return CPropertyPage::OnSetActive();
}

void DataBasePage::OnSize(UINT nType, int cx, int cy) 
{
	CPropertyPage::OnSize(nType, cx, cy);
	//AfxGetMainWnd()->GetWindowText(m_szDBName);
	//m_stDB_NAME.SetWindowText(m_szDBName);   
	// TODO: Add your message handler code here
	
}

void DataBasePage::OnMETHOD1Calc() 
{
	// TODO: Add your control notification handler code here
	g_nMETHOD1Calc=1;
}

void DataBasePage::OnMETHOD1Calculator() 
{
	// TODO: Add your control notification handler code here
	g_nMETHOD1Calc=0;
}

void DataBasePage::OnButtonOpenDb() 
{
	// TODO: Add your control notification handler code here
	//char str[1000];
	UpdateData();
	CWnd* pw=AfxGetMainWnd();
	pw->SendMessage(WM_COMMAND,ID_FILE_OPEN,0);	
	if(m_pView)
	{
	   m_szDBName=m_pView->GetDocument()->GetTitle();
	   m_stDB_NAME.SetWindowText(m_szDBName); 
	}   
    UpdateData(FALSE);
	Invalidate();
	//OnPatient(); 
    //pw->SendMessage(WM_COMMAND,ID_FILE_CLOSE,0);	
}

void DataBasePage::OnButtonSaveDbAs() 
{
	// TODO: Add your control notification handler code here
    AfxGetMainWnd()->SendMessage(WM_COMMAND,ID_FILE_SAVE_AS,0);	
    if(m_pView)
	{
	   m_szDBName=m_pView->GetDocument()->GetTitle();
	   m_stDB_NAME.SetWindowText(m_szDBName); 
	}   
}

void DataBasePage::OnDbName() 
{
	// TODO: Add your control notification handler code here
	if(m_pView)
	{
	   m_szDBName=m_pView->GetDocument()->GetTitle();
	   m_stDB_NAME.SetWindowText(m_szDBName); 
	   OnPatient();
	}   
}

void DataBasePage::OnButtonCloseApp() 
{
	// TODO: Add your control notification handler code here
	AfxGetMainWnd()->SendMessage(WM_COMMAND,ID_FILE_CLOSE,0);	
}
