// NewEditLensDial.cpp : implementation file
//

#include "stdafx.h"
//#include "YtvUltraSoundMedScan0.h"
#include "NewEditLensDial.h"
#include "resource.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// NewEditLensDial dialog
entypeRegistryNodes NewEditLensDial::m_enTypeRegNode=encEditNewLensTypeRec;
char* NewEditLensDial::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* NewEditLensDial::m_pszDoctorRecFormat[]={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* NewEditLensDial::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* NewEditLensDial::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* NewEditLensDial::m_pszLensTypeRecFormat[]=       {"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* NewEditLensDial::m_pszFullLensTypeRecFormat[]=   {"LensMfg","LensName","MfgA_Const","pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* NewEditLensDial::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg","MfgA_Const","MfgACD","OD1","OD2",
	                                                    "OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
struct sttypeRegistryNodes NewEditLensDial::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL}
};

NewEditLensDial::NewEditLensDial(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	
	m_szAdded.Empty();// = _T("");
	m_szMETHOD1_acd.Empty();// = _T("");
	m_szMETHOD0_sf.Empty();// = _T("");
	m_szLansename.Empty();// = _T("");
	m_szLensemfg.Empty();// = _T("");
	m_szLoop_angle.Empty();// = _T("");
	m_szLoop_material.Empty();// = _T("");
	m_szMfg_a_const.Empty();// = _T("");
	m_szMfg_acd.Empty();// = _T("");
	m_szMfg_sf.Empty();// = _T("");
	m_szOptic_diam1.Empty();// = _T("");
	m_szOptic_diam2.Empty();// = _T("");
	m_szOptik_material.Empty();// = _T("");
	m_szOver_lenght.Empty();// = _T("");
	m_szPc.Empty();// = _T("");
	m_szPower_range.Empty();// = _T("");
	m_szNote.Empty();// = _T("");
	m_strValidMessage.Empty();// = _T("");
	//{{AFX_DATA_INIT(NewEditLensDial)
	//}}AFX_DATA_INIT
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,255,255); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(255,255,255);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,255); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,255);
	m_clrEditBoxesFront=RGB(0,0,0);
	m_clrScrollBarsBrush=RGB(255,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
}


void NewEditLensDial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//if(!pDX)
	//	return;
	//{{AFX_DATA_MAP(NewEditLensDial)	
	DDX_Text(pDX, IDC_ADDED, m_szAdded);
	DDX_Text(pDX, IDC_METHOD1_ACD, m_szMETHOD1_acd);
	DDX_Text(pDX, IDC_METHOD0_SF, m_szMETHOD0_sf);
	DDX_Text(pDX, IDC_LENSENAME, m_szLansename);
	DDX_Text(pDX, IDC_LENSMFG, m_szLensemfg);
	DDX_Text(pDX, IDC_LOOP_ANGLE, m_szLoop_angle);
	DDX_Text(pDX, IDC_LOOP_MATERIAL, m_szLoop_material);
	DDX_Text(pDX, IDC_MFG_A_CONST, m_szMfg_a_const);
	DDX_Text(pDX, IDC_MFG_ACD, m_szMfg_acd);
	DDX_Text(pDX, IDC_MFG_SF, m_szMfg_sf);
	DDX_Text(pDX, IDC_OPTIC_DIAM1, m_szOptic_diam1);
	DDX_Text(pDX, IDC_OPTIC_DIAM2, m_szOptic_diam2);
	DDX_Text(pDX, IDC_OPTIC_MATERIAL, m_szOptik_material);
	DDX_Text(pDX, IDC_OVER_LENGHT, m_szOver_lenght);
	DDX_Text(pDX, IDC_PC, m_szPc);
	DDX_Text(pDX, IDC_POWER_RANGE, m_szPower_range);
	DDX_Text(pDX, IDC_NOTE, m_szNote);
	DDX_Text(pDX, IDC_VALID_MESSAGE_LENS, m_strValidMessage);
	DDX_Control(pDX, ID__LOK, m_btOk);
	DDX_Control(pDX, ID__LCANCEL, m_btCancel);
	DDX_Control(pDX, IDC_POWER_RANGE, m_cntrPower_range);
	DDX_Control(pDX, IDC_PC, m_cntrPc);
	DDX_Control(pDX, IDC_OVER_LENGHT, m_cntrOver_lenght);
	DDX_Control(pDX, IDC_OPTIC_MATERIAL, m_cntrOptic_material);
	DDX_Control(pDX, IDC_OPTIC_DIAM2, m_cntrOptic_diam2);
	DDX_Control(pDX, IDC_OPTIC_DIAM1, m_cntrOptic_diam1);
	DDX_Control(pDX, IDC_MFG_SF, m_cntrMfg_sf);
	DDX_Control(pDX, IDC_MFG_ACD, m_cntrMfg_acd);
	DDX_Control(pDX, IDC_MFG_A_CONST, m_cntrMfg_a_const);
	DDX_Control(pDX, IDC_LOOP_MATERIAL, m_cntrLoop_material);
	DDX_Control(pDX, IDC_LOOP_ANGLE, m_cntrLoop_angle);
	DDX_Control(pDX, IDC_LENSMFG, m_cntrLansemfg);
	DDX_Control(pDX, IDC_LENSENAME, m_cntrLansename);
	DDX_Control(pDX, IDC_METHOD0_SF, m_cntrMETHOD0_sf);
	DDX_Control(pDX, IDC_METHOD1_ACD, m_cntrMETHOD1_acd);
	DDX_Control(pDX, IDC_ADDED, m_cntrAdded);	
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(NewEditLensDial, CDialog)
	//{{AFX_MSG_MAP(NewEditLensDial)
	ON_WM_CTLCOLOR()
	ON_EN_KILLFOCUS(IDC_MFG_A_CONST, OnKillfocusMfgAConst)
	ON_EN_KILLFOCUS(IDC_MFG_ACD, OnKillfocusMfgAcd)
	ON_EN_KILLFOCUS(IDC_METHOD1_ACD, OnKillfocusMETHOD1Acd)
	ON_EN_KILLFOCUS(IDC_MFG_SF, OnKillfocusMfgSf)
	ON_EN_KILLFOCUS(IDC_METHOD0_SF, OnKillfocusMETHOD0Sf)
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(ID__LCANCEL, OnLcancel)
	ON_BN_CLICKED(ID__LOK, OnLok)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// NewEditLensDial message handlers

HBRUSH NewEditLensDial::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	  switch(nCtlColor)
	{
		default:
            hbr=CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
			return hbr;
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	hbr=CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	  return hbr;
}

BOOL NewEditLensDial::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	m_enTypeRegNode=encEditNewLensTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
	if(m_bEdit)
    {
      SetWindowText("Edit Lens");
      ReadRegDB();
    }
	else
        SetWindowText("New Lens");
    //m_cntrLansename.SetFocus();
	return TRUE;//FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void NewEditLensDial::OnOK() 
{
	// TODO: Add extra validation here
	if(::GetFocus() != ::GetDlgItem (m_hWnd, IDOK))
	{
	    NextDlgCtrl(); // Tab to next edit box
		return;
    }
	if(!m_pdb)
    {
			//MessageBox("Test13");
        	DestroyWindow();
	        return;
    }
	UpdateData(TRUE);
	if(m_szLensemfg.IsEmpty())
	{
		//DestroyWindow();
	    //delete this;
			//MessageBox("Test12");
		return;
	}	
		//MessageBox("Test11");
	WriteRegDB();
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
		//MessageBox("Test10");
	DestroyWindow();
	//CDialog::OnOK();
}
int NewEditLensDial::WriteRegDB()
{
//"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2"
//	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt"
//	,"pA_Const", "pACD",  "pSF"
	UpdateData();
	YtvWriteProfileString(m_szLensemfg,"Ad",m_szAdded,1);
	YtvWriteProfileString(m_szLensemfg,"Hacd",m_szMETHOD1_acd,1);
	YtvWriteProfileString(m_szLensemfg,"Hd",m_szMETHOD0_sf,1);
	YtvWriteProfileString(m_szLensemfg,"LensName",m_szLansename,1);
	YtvWriteProfileString(m_szLensemfg,"LensMfg",m_szLensemfg,1);
	YtvWriteProfileString(m_szLensemfg,"LA",m_szLoop_angle,1);
	YtvWriteProfileString(m_szLensemfg,"LM",m_szLoop_material,1);
	YtvWriteProfileString(m_szLensemfg,"MfgA_Const",m_szMfg_a_const,1);
	YtvWriteProfileString(m_szLensemfg,"MfgACD",m_szMfg_acd,1);
	YtvWriteProfileString(m_szLensemfg,"MfgSF",m_szMfg_sf,1);
	YtvWriteProfileString(m_szLensemfg,"OD1",m_szOptic_diam1,1);
	YtvWriteProfileString(m_szLensemfg,"OD2",m_szOptic_diam2,1);
	YtvWriteProfileString(m_szLensemfg,"OM",m_szOptik_material,1);
	YtvWriteProfileString(m_szLensemfg,"OL",m_szOver_lenght,1);
	YtvWriteProfileString(m_szLensemfg,"PC",m_szPc,1);
	YtvWriteProfileString(m_szLensemfg,"PR",m_szPower_range,1);
    YtvWriteProfileString(m_szLensemfg,"Nt",m_szNote,1);
   return 17;

}
int NewEditLensDial::ReadRegDB()
{
//"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2"
//	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt"
//	,"pA_Const", "pACD",  "pSF"
    m_szAdded=YtvGetProfileString(m_szLensemfg,"Ad","",1);
	m_szMETHOD1_acd=YtvGetProfileString(m_szLensemfg,"Hacd","",1);
	m_szMETHOD0_sf=YtvGetProfileString(m_szLensemfg,"Hd","",1);
	m_szLansename=YtvGetProfileString(m_szLensemfg,"LensName","",1);
	m_szLensemfg=YtvGetProfileString(m_szLensemfg,"LensMfg","",1);
	m_szLoop_angle=YtvGetProfileString(m_szLensemfg,"LA","",1);
	m_szLoop_material=YtvGetProfileString(m_szLensemfg,"LM","",1);
	m_szMfg_a_const=YtvGetProfileString(m_szLensemfg,"MfgA_Const","",1);
	m_szMfg_acd=YtvGetProfileString(m_szLensemfg,"MfgACD","",1);
	m_szMfg_sf=YtvGetProfileString(m_szLensemfg,"MfgSF","",1);
	m_szOptic_diam1=YtvGetProfileString(m_szLensemfg,"OD1","",1);
	m_szOptic_diam2=YtvGetProfileString(m_szLensemfg,"OD2","",1);
	m_szOptik_material=YtvGetProfileString(m_szLensemfg,"OM","",1);
	m_szOver_lenght=YtvGetProfileString(m_szLensemfg,"OL","",1);
	m_szPc=YtvGetProfileString(m_szLensemfg,"PC","",1);
	m_szPower_range=YtvGetProfileString(m_szLensemfg,"PR","",1);
	m_szNote=YtvGetProfileString(m_szLensemfg,"Nt","",1);
	UpdateData(FALSE);
return 17;

}

void NewEditLensDial::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(!m_pdb)
    {
			//MessageBox("Test7");
        	DestroyWindow();
	      	return;
    }
		//MessageBox("Test8");
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
		//MessageBox("Test9");
	DestroyWindow();
	//CDialog::OnCancel();
}

BOOL NewEditLensDial::Create(CWnd* pParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pdb=(DataBasePage*)pParentWnd;
	BOOL b=CDialog::Create(IDD, pParentWnd);
	return b;
}

void NewEditLensDial::OnKillfocusMfgAConst() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szMfg_a_const);
	 if(temp>=110.0 && temp<=130.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Mfg A const is invalid (110<=A const<=130)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrMfg_a_const.SetFocus();
	 UpdateData(FALSE);
}

void NewEditLensDial::OnKillfocusMfgAcd() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szMfg_acd);
	 if(temp>=1.0 && temp<=6.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Mfg ACD is invalid (1<=ACD<=6)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrMfg_acd.SetFocus();
	 UpdateData(FALSE);
}

void NewEditLensDial::OnKillfocusMETHOD1Acd() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szMETHOD1_acd);
	 if(temp>=1.0 && temp<=6.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="METHOD1 ACD is invalid (1<=ACD<=6)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrMETHOD1_acd.SetFocus();
	 UpdateData(FALSE);
}

void NewEditLensDial::OnKillfocusMfgSf() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szMfg_sf);
	 if(temp>=-3.3 && temp<=8.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="Mfg SF is invalid (-3.3<=SF<=8)";
	 MessageBeep(MB_ICONQUESTION);
	 //m_cntrMfg_sf.SetFocus();
	 UpdateData(FALSE);
}

void NewEditLensDial::OnKillfocusMETHOD0Sf() 
{
	// TODO: Add your control notification handler code here
	 UpdateData();
	 double temp=atof(m_szMETHOD0_sf);
	 if(temp>=-3.3 && temp<=8.0)
	 {
		 m_strValidMessage.Empty();
		 UpdateData(FALSE);
		 return;
     }
	 m_strValidMessage="METHOD0 SF is invalid (-3.3<=SF<=8)";
	 MessageBeep(MB_ICONQUESTION);
//	 m_cntrMETHOD0_sf.SetFocus();
	 UpdateData(FALSE);
}
/*
void NewEditLensDial::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	//CDialog::OnShowWindow(bShow, nStatus);
	ShowWindow(SW_MAXIMIZE);
	// TODO: Add your message handler code here
	
}*/

void NewEditLensDial::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);
}

void NewEditLensDial::OnLcancel() 
{
	// TODO: Add your control notification handler code here
	//OnCancel();
	if(!m_pdb)
    {
			//MessageBox("Test5");
        	DestroyWindow();
	       	return;
    }
	////MessageBox("Test6");
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
	//MessageBox("Test4");
	if(IsWindow(m_hWnd))
	{
		//MessageBox("Test14LCancel");
		DestroyWindow();
	}
	//MessageBox("Test19");
	//delete this;
}

void NewEditLensDial::OnLok() 
{
	// TODO: Add your control notification handler code here
	//OnOK();
	if(::GetFocus() != ::GetDlgItem (m_hWnd, ID__LOK))
	{
		if(::GetFocus() == ::GetDlgItem (m_hWnd, ID__LCANCEL))
        {
             OnLcancel();
			 return;
        }
		else
		{
		    NextDlgCtrl(); // Tab to next edit box
			return;
		}
    }
	if(!m_pdb)
    {
		    	//MessageBox("Test2");
        	DestroyWindow();
	       	return;
    }
	UpdateData(TRUE);
	if(m_szLensemfg.IsEmpty())
	{
		//DestroyWindow();
	    //delete this;
			//MessageBox("Test1");
		return;
	}	
	WriteRegDB();
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	m_pdb->ReadRegistryDB();
	m_pdb->UpdateData(FALSE);
	//MessageBox("Test0");
	DestroyWindow();
	
}

void NewEditLensDial::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	//MessageBox("Test");
	TRY
    {
	   delete this;
    }
	CATCH_ALL(e)
    {

    }
	END_CATCH_ALL
	//MessageBox("Testexit");
	//CDialog::PostNcDestroy();
}
/*
BOOL NewEditLensDial::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	BOOL b;
	//MessageBox("Test15");  
	b=CDialog::DestroyWindow();
	//b=m_btCancel.DestroyWindow(); 
	//b=m_btOk.DestroyWindow(); 
	return TRUE;
}*/
