// PatientHistoryDial.cpp : implementation file
//

#include "stdafx.h"
//#include "YtvUltraSoundMedScan0.h"
#include "PatientHistoryDial.h"
//#include "MeasurementPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PatientHistoryDial dialog
extern struct g_structTablScales
{
   unsigned speed;
   double mm1pixel;
   double Length;
   char MethodsModesRegim;
}g_structTablScales[3];
extern double g_dCurrentScaleLength;
extern unsigned g_nCurrentSpeed;
BOOL g_bPatientHistoryShowSdAvGrids=FALSE;
extern BOOL g_bShowDbScanId;
int g_nHistoreyAvAlFontHeight=40;
extern int g_nHorLineY;
extern int g_nHorMarkLen;
extern int g_nVerMarkLen;
extern int g_nRow;
extern CString g_szPatientId;
entypeRegistryNodes PatientHistoryDial::m_enTypeRegNode=encFullLensTypeRec;
char* PatientHistoryDial::m_pszPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt",NULL};
char* PatientHistoryDial::m_pszDoctorRecFormat[]={"OficeName","OficeAddress","DoctorID","FirstName","LastName",NULL};
char* PatientHistoryDial::m_pszLensTypeRecFormat[]={"LensMfg","LensName","MfgA_Const","MfgACD","MfgSF",NULL};
char* PatientHistoryDial::m_pszFullPatientRecFormat[]={"PatientID","FirstName","LastName","DoctorName", "Nt","DoctorID","DateOfBirth","Sex","Address","City","State","Zip","Phone","RiK1V","RiK2V","RiKV","LeK1V","LeK2V","LeKV",NULL};
char* PatientHistoryDial::m_pszFullDoctorRecFormat[]={"DoctorID","FirstName","LastName","Nt","OficeName","OficeAddress",NULL};
char* PatientHistoryDial::m_pszFullLensTypeRecFormat[]={"LensMfg","LensName", "MfgA_Const", "pA_Const", "MfgACD", "pACD", "MfgSF", "pSF",NULL};
char* PatientHistoryDial::m_pszEditNewLensTypeRecFormat[]={"LensName","LensMfg", "MfgA_Const", "MfgACD","OD1","OD2",
	"OL","LA","PR","OM","LM","PC","Ad","MfgSF","Hd","Hacd","Nt",NULL};
char* PatientHistoryDial::m_pszMeasureHistoryTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
char* PatientHistoryDial::m_pszCalculatorTypeRecFormat[]={"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","AutoManualVCR","ScData","OutDist","SG","Av","Flt","CTh","LTh1","LTh2","RTh","AvAl","SD",NULL};
struct sttypeRegistryNodes PatientHistoryDial::m_arListReg[]=
{
	{"CommonSettings",NULL,NULL},
	{"Patients",m_pszPatientRecFormat,NULL},
    {"Doctors",m_pszDoctorRecFormat,NULL},
	{"LensesType",m_pszLensTypeRecFormat,NULL},
    {"Patients",m_pszFullPatientRecFormat,NULL},
    {"Doctors",m_pszFullDoctorRecFormat,NULL},
	{"LensesType",m_pszFullLensTypeRecFormat,NULL},
	{"LensesType",m_pszEditNewLensTypeRecFormat,NULL},
	{"Sessions",m_pszMeasureHistoryTypeRecFormat,NULL},
	{"Sessions",m_pszCalculatorTypeRecFormat,NULL}

};

PatientHistoryDial::PatientHistoryDial(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	//{{AFX_DATA_INIT(PatientHistoryDial)
	m_stleftAverageValue = _T("");
	m_stRightAvaerageValue = _T("");
	m_stRightSdValue = _T("");
	m_stLeftSdValue = _T("");
	m_stlbmark = _T("");
	m_strbmark = _T("");
	m_stal_av_velocity = _T("");
	m_stAcd = _T("");
	m_stAxisLength = _T("");
	m_stDoctorName = _T("");
	m_stLt = _T("");
	m_stPatientId = _T("");
	m_stPatientName = _T("");
	m_stVit = _T("");
	m_ctDateTime = 0;
	m_AxialLength = _T("");
	m_szAverage = _T("");
	m_szAvAl = _T("");
	//}}AFX_DATA_INIT
	m_clrDialBack=RGB(0,0,0);
	m_clrDialFront=RGB(0,0,0);
	m_clrDialBrush=RGB(0,255,0);    
   	m_hbrDialBrush=CreateSolidBrush(m_clrDialBrush);
	m_clrButtonsBrush=RGB(255,255,255); 
	m_hbrButtonsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrButtonsBack=RGB(255,0,0);
	m_clrButtonsFront=RGB(255,255,255);
	m_clrStaticBrush=RGB(0,255,0); 
	m_clrStaticBack=RGB(0,255,0);
	m_clrStaticFront=RGB(0,0,0);
	m_hbrStaticBrush=CreateSolidBrush(m_clrStaticBrush);
	m_clrMsgBoxesBrush=RGB(255,0,0); 
	m_hbrMsgBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrMsgBoxesBack=RGB(255,0,0);
	m_clrMsgBoxesFront=RGB(255,255,255);
	m_clrEditBoxesBrush=RGB(255,255,0); 
	m_hbrEditBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrEditBoxesBack=RGB(255,255,0);
	m_clrEditBoxesFront=RGB(255,0,255);
	m_clrScrollBarsBrush=RGB(0,0,0); 
	m_hbrScrollBarsBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrScrollBarsBack=RGB(255,0,0);
	m_clrScrollBarsFront=RGB(255,255,255);
	m_clrListBoxesBrush=RGB(255,0,0); 
	m_hbrListBoxesBrush=CreateSolidBrush(m_clrButtonsBrush);
	m_clrListBoxesBack=RGB(255,0,0);
	m_clrListBoxesFront=RGB(255,255,255);
	

}


void PatientHistoryDial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PatientHistoryDial)
	DDX_Control(pDX, IDC_STRAV3, m_stAvelo);
	DDX_Control(pDX, IDC_HISTOTY_AVER_AL, m_stAvAL);
	DDX_Control(pDX, IDOK, m_btOK);
	DDX_Control(pDX, IDC_GRID_LEFTHISTORY, m_gridLeftView);
	DDX_Control(pDX, IDC_GRIDRIGHTHISTORY, m_gridRightView);
	DDX_Control(pDX, IDC_GRID_SESSIONS, m_gridSessions);
	DDX_Control(pDX, IDC_PATIENTIDNAMEDOCTOR, m_gridPatIdNamDoc);
	DDX_Control(pDX, IDC_HISTORY_AL_ACD_LT_VIT, m_gridHistoryAlAcdLtVit);
	DDX_Control(pDX, IDC_HISTORY_R_AVER_SD, m_gridHistoryRAverSd);
	DDX_Control(pDX, IDC_HISTORY_L_AVER_SD, m_gridHistoryLAverSd);
	DDX_Text(pDX, IDC_HISTOTY_AVER_AL, m_szAvAl);
	DDX_Control(pDX, IDC_YTVHISTGRAPHCTRLCTRL, m_imHistoryGraph);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PatientHistoryDial, CDialog)
	//{{AFX_MSG_MAP(PatientHistoryDial)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// PatientHistoryDial message handlers

HBRUSH PatientHistoryDial::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	if(pWnd==&m_imHistoryGraph)
		return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	if(&m_stAvAL==pWnd)
    {
         SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
		 SetBkColor(pDC->m_hDC,m_clrEditBoxesBack); 
		 m_hbrDialBrush;
    }
	switch(nCtlColor)
	{
		default:

			return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
			
		case CTLCOLOR_BTN: //  Button control
            SetTextColor(pDC->m_hDC,m_clrButtonsFront);
			SetBkColor(pDC->m_hDC,m_clrButtonsBack); 
            return m_hbrButtonsBrush;
						            
        case CTLCOLOR_DLG://   Dialog box
            SetTextColor(pDC->m_hDC,m_clrDialFront);
			SetBkColor(pDC->m_hDC,m_clrDialBack); 
            return m_hbrDialBrush;               
case CTLCOLOR_EDIT://   Edit control
            SetTextColor(pDC->m_hDC,m_clrEditBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrEditBoxesBack);  
            return m_hbrEditBoxesBrush;
case CTLCOLOR_LISTBOX://   List-box control
            SetTextColor(pDC->m_hDC,m_clrListBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrListBoxesBack);  
            return m_hbrListBoxesBrush;
case CTLCOLOR_MSGBOX://   Message box
            SetTextColor(pDC->m_hDC,m_clrMsgBoxesFront);
			SetBkColor(pDC->m_hDC,m_clrMsgBoxesBack); 
			return m_hbrMsgBoxesBrush;
case CTLCOLOR_SCROLLBAR://   Scroll-bar control
            SetTextColor(pDC->m_hDC,m_clrScrollBarsFront);
			SetBkColor(pDC->m_hDC,m_clrScrollBarsBack);  
            return m_hbrScrollBarsBrush;
case CTLCOLOR_STATIC://   Static control 
            SetTextColor(pDC->m_hDC,m_clrStaticFront); 
            SetBkColor(pDC->m_hDC,m_clrStaticBack); 
            return m_hbrStaticBrush;
	}
	
	// TODO: Return a different brush if the default is not desired
	return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
}

BOOL PatientHistoryDial::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ShowWindow(SW_MAXIMIZE);
	// TODO: Add extra initialization here
	m_gridSessions.SetRows(20);		
	m_gridSessions.SetCols(3);	
	m_gridSessions.SetFixedCols(0);
	m_gridSessions.SetColWidth(0,1240);
	m_gridSessions.SetColWidth(1,1440);
	m_gridSessions.SetColWidth(2,1228);
    m_gridSessions.SetTextMatrix(0, 0, "Sessions No"); 
    m_gridSessions.SetTextMatrix(0, 1, "Sessions Date"); 
	m_gridSessions.SetTextMatrix(0, 2, "No of Scans"); 
/////////////////////////////////////////////////////////////////
	m_gridRightView.SetRows(65);		
	m_gridRightView.SetCols(7);	
	m_gridRightView.SetFixedCols(0);
	m_gridRightView.SetColWidth(0,850);
	m_gridRightView.SetColWidth(1,1120);
	m_gridRightView.SetColWidth(2,1100);
    m_gridRightView.SetColWidth(3,800);
    m_gridRightView.SetTextMatrix(0, 0, "Scan No"); 
    m_gridRightView.SetTextMatrix(0, 1, "Method"); 
	m_gridRightView.SetTextMatrix(0, 2, "Mode"); 
    m_gridRightView.SetTextMatrix(0, 3, "AL"); 
	m_gridRightView.SetTextMatrix(0, 4, "ACD"); 
	m_gridRightView.SetTextMatrix(0, 5, "LT");
	m_gridRightView.SetTextMatrix(0, 6, "VIT"); 
	//////////////////////////////////////////////////////////////
	m_gridLeftView.SetRows(20);		
	m_gridLeftView.SetCols(7);	
	m_gridLeftView.SetFixedCols(0);
	m_gridLeftView.SetColWidth(0,850);
	m_gridLeftView.SetColWidth(1,1120);
	m_gridLeftView.SetColWidth(2,1100);
	m_gridLeftView.SetColWidth(3,800);
    m_gridLeftView.SetTextMatrix(0, 0, "Scan No"); 
    m_gridLeftView.SetTextMatrix(0, 1, "Method"); 
	m_gridLeftView.SetTextMatrix(0, 2, "Mode"); 
	m_gridLeftView.SetTextMatrix(0, 3, "AL"); 
	m_gridLeftView.SetTextMatrix(0, 4, "ACD"); 
	m_gridLeftView.SetTextMatrix(0, 5, "LT");
	m_gridLeftView.SetTextMatrix(0, 6, "VIT"); 
	////////////////////////////////////////////////////////
	m_gridPatIdNamDoc.SetRows(3);		
	m_gridPatIdNamDoc.SetCols(2);	
	m_gridPatIdNamDoc.SetFixedRows(0);
	m_gridPatIdNamDoc.SetColWidth(0,1350);
	m_gridPatIdNamDoc.SetColWidth(1,3350);
//	m_gridPatIdNamDoc.SetColWidth(2,950);
    m_gridPatIdNamDoc.SetTextMatrix(0, 0, "Patient ID"); 
    m_gridPatIdNamDoc.SetTextMatrix(1, 0, "Patient Name"); 
	m_gridPatIdNamDoc.SetTextMatrix(2, 0, "Doctor Name"); 
	/////////////////////////////////////////////////////////
	m_gridHistoryAlAcdLtVit.SetRows(4);		
	m_gridHistoryAlAcdLtVit.SetCols(3);	
	m_gridHistoryAlAcdLtVit.SetFixedRows(0);
	m_gridHistoryAlAcdLtVit.SetColWidth(0,2900);
	m_gridHistoryAlAcdLtVit.SetColWidth(1,1375);
	m_gridHistoryAlAcdLtVit.SetColWidth(2,450);
    m_gridHistoryAlAcdLtVit.SetTextMatrix(0, 0, "Axial Lenght as: ACD+LT+VIT"); 
    m_gridHistoryAlAcdLtVit.SetTextMatrix(1, 0, "ACD @ 1555 m/sec"); 
	m_gridHistoryAlAcdLtVit.SetTextMatrix(2, 0, "LT @ 1551 m/sec"); 
	m_gridHistoryAlAcdLtVit.SetTextMatrix(3, 0, "VIT @ 1552 m/sec"); 
    m_gridHistoryAlAcdLtVit.SetTextMatrix(0, 2, "mm"); 
    m_gridHistoryAlAcdLtVit.SetTextMatrix(1, 2, "mm"); 
	m_gridHistoryAlAcdLtVit.SetTextMatrix(2, 2, "mm"); 
	m_gridHistoryAlAcdLtVit.SetTextMatrix(3, 2, "mm");
	////////////////////////////////////////////////////
	m_gridHistoryLAverSd.SetRows(2);		
	m_gridHistoryLAverSd.SetCols(2);	
	m_gridHistoryLAverSd.SetFixedRows(0);
	m_gridHistoryLAverSd.SetColWidth(0,940);
	m_gridHistoryLAverSd.SetColWidth(1,940);
//	m_gridHistoryLAverSd.SetColWidth(2,1240);
    m_gridHistoryLAverSd.SetTextMatrix(0, 0, "Average"); 
    m_gridHistoryLAverSd.SetTextMatrix(1, 0, "SD"); 
//	m_gridHistoryLAverSd.SetTextMatrix(2, 0, "Average"); 
	///////////////////////////////////////////////////////////
	m_gridHistoryRAverSd.SetRows(2);		
	m_gridHistoryRAverSd.SetCols(2);	
	m_gridHistoryRAverSd.SetFixedRows(0);
	m_gridHistoryRAverSd.SetColWidth(0,940);
	m_gridHistoryRAverSd.SetColWidth(1,940);
    m_gridHistoryRAverSd.SetTextMatrix(0, 0, "Average"); 
    m_gridHistoryRAverSd.SetTextMatrix(1, 0, "SD"); 
	/////////////////////////////////////////////////////	;
    m_nMemorySize=1024;
	for(int i=0;i<m_nMemorySize;i++)
          m_npDataBuf[i]=0;
    m_imHistoryGraph.SetIPoints((long*)m_npDataBuf,m_nMemorySize);
    InitGraph();
//	m_nManualMeasureCount=0;

	m_font.CreateFont(g_nHistoreyAvAlFontHeight, 0, 0, 0, FW_BOLD, FALSE, FALSE,
               0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
               CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
               FF_DONTCARE, NULL);  
    m_stAvAL.SetFont(&m_font);
	ReadRegDB();
	m_gridLeftView.SetRowSel(0);
	m_gridRightView.SetRowSel(0);
	if(g_bPatientHistoryShowSdAvGrids)
    {
        m_gridHistoryRAverSd.ShowWindow(SW_SHOW);
        m_gridHistoryLAverSd.ShowWindow(SW_SHOW);
    }
	else
    {
        m_gridHistoryRAverSd.ShowWindow(SW_HIDE);
        m_gridHistoryLAverSd.ShowWindow(SW_HIDE);
    }
    Invalidate();  
	m_imHistoryGraph.Invalidate();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
void PatientHistoryDial::InitGraph()
{
	RECT rt;
    m_imHistoryGraph.GetWindowRect(&rt);
	rt.bottom-=rt.top;
	rt.right-=rt.left;	
	short BegY=(short)rt.bottom;
	short LenX=(short)rt.right;
	short LenY=(short)rt.bottom;
	short HSmall=10;
	short HMedium=18;
	short HLong=24;	
    short StepSmall=(short)(((double)rt.right)/39.5+0.5);
	short StepLong=StepSmall*10;
	short StepMedium=StepSmall*5;
	short DirectionUpDownCenter=-1;
	short AxisLineType=1;
	short nNewValue=0;
	short BegX=0;
	long TextStepSmall=0;
	long TextStepMedium=5;
	long TextStepLong=10;
	long TextBeginCount=0;
	m_imHistoryGraph.SetScalePlank(&BegX, &BegY, &LenX, &LenY, &HSmall, &HMedium, &HLong, &StepSmall, &StepMedium, &StepLong, &DirectionUpDownCenter, &AxisLineType, nNewValue);
   	m_imHistoryGraph.SetScalePlankTextHoriz(&TextStepSmall, &TextStepMedium, &TextStepLong, TextBeginCount); 
	m_imHistoryGraph.SetDrawScalePlank(TRUE);
	m_imHistoryGraph.SetBottomVerticalPosition(HLong);
	m_imHistoryGraph.SetTopVerticalPosition(5);
	m_imHistoryGraph.SetCleanByBrush(TRUE);  
}
void PatientHistoryDial::DisplayGraph()
{
//m_imGraph.CleanReDraw(0);
m_imHistoryGraph.SetIPoints((long *)m_npDataBuf,m_nMemorySize);
DrawMarks(0);
m_imHistoryGraph.Invalidate(FALSE);
m_imHistoryGraph.UpdateWindow();
}
int PatientHistoryDial::ReadRegDB()
{   

    m_gridPatIdNamDoc.SetTextMatrix(0, 1, g_szPatientId);
    m_szPatient_Id=g_szPatientId;
	if(m_szPatient_Id.IsEmpty())
	   return 0;
    m_enTypeRegNode=encFullPatientTypeRec;
	YtvSetAdditionalRegNode(m_arListReg[m_enTypeRegNode].Node);
    int j;
	CString Temp0,Temp1;
	char *pf;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return 0;  
    pf=m_arListReg[m_enTypeRegNode].Format[2];
	if(pf==NULL)
		return 0;
	UpdateData();
	m_arListReg[encFullPatientTypeRec].Data=new CString[30];
	for(j=0;;j++)
    {
           pf=m_arListReg[m_enTypeRegNode].Format[j];
		   if(pf==NULL)
			   break;
		   m_arListReg[m_enTypeRegNode].Data[j]=YtvGetProfileString(m_szPatient_Id,pf,"",1); 		 
    }   
	m_szFirstname=m_arListReg[encFullPatientTypeRec].Data[1];
	m_szLastname=m_arListReg[encFullPatientTypeRec].Data[2];
	Temp0=m_szFirstname+' '+m_szLastname;
	Temp0.TrimLeft();
	m_gridPatIdNamDoc.SetTextMatrix(1, 1, Temp0); 
    m_szDoctorName=m_arListReg[encFullPatientTypeRec].Data[3];
	m_gridPatIdNamDoc.SetTextMatrix(2, 1,m_szDoctorName);
    m_szNote=m_arListReg[encFullPatientTypeRec].Data[4];
	m_szDoctorId=m_arListReg[encFullPatientTypeRec].Data[5];
	Temp0=m_arListReg[encFullPatientTypeRec].Data[6];
	j=Temp0.Find('/');
	if(j>0)
	{
		m_szDob_mm=Temp0.Left(j);
		Temp0=Temp0.Mid(j+1);
        j=Temp0.Find('/');
	    if(j>0)
		{
           m_szDob_dd=Temp0.Left(j);
		   m_szDob_yy=Temp0.Mid(j+1);
        }
    }	
	if(m_arListReg[encFullPatientTypeRec].Data[7]=="M")
	      m_nGender=0;
    else
          m_nGender=1;
	m_szP_Address=m_arListReg[encFullPatientTypeRec].Data[8];
	m_szP_city=m_arListReg[encFullPatientTypeRec].Data[9];
    m_szP_state=m_arListReg[encFullPatientTypeRec].Data[10];
    m_szP_zip=m_arListReg[encFullPatientTypeRec].Data[11];
	m_szP_phone=m_arListReg[encFullPatientTypeRec].Data[12];
    m_szK1_value_r=m_arListReg[encFullPatientTypeRec].Data[13];
    m_szK2_value_r=m_arListReg[encFullPatientTypeRec].Data[14];
	m_szK_value_r=m_arListReg[encFullPatientTypeRec].Data[15];
	m_szK1_value_l=m_arListReg[encFullPatientTypeRec].Data[16];
    m_szK2_value_l=m_arListReg[encFullPatientTypeRec].Data[17];
	m_szK_value_l=m_arListReg[encFullPatientTypeRec].Data[18];	
	delete []m_arListReg[encFullPatientTypeRec].Data;
    m_arListReg[encFullPatientTypeRec].Data=NULL;
	///////////// read scan data inside patient /////////////
    ReadRegAllSessions();
	//OnAuto();
//    OnOdOs();
	m_nManualMeasureCount=0;
	return 19;
}
int PatientHistoryDial::ReadRegAllSessions()
{
    CString Temp0;
	m_nODLastSelectedScanNumber=0;
	m_nOSLastSelectedScanNumber=0;
	m_nAllLastSelectedScanNumber=0;
	m_dRTotalAL=m_dLTotalAL=0.0;
    m_enTypeRegNode=encMeasureHistorySessionScansTypeRec;   
	CString Section=m_szPatient_Id;
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Node;
	int NumbRecords=0,i,j;
	char* pch,*pchtemp;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return NumbRecords;
	Section+='\\';
    int numbchar=YtvGetProfileSection(Section,NULL,0,1);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
	if(numbchar==0)
	{
		delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	CString Subsection;
	Section+="\\";
	for(i=1;pchtemp[0];i++,pchtemp+=strlen(pchtemp)+1)
    {
       Temp0=pchtemp;
	   Temp0.Replace('_','/');
       m_gridSessions.SetTextMatrix(i,1,Temp0);
	   j=CountNumberOfScans(Temp0);  
       Temp0.Format("%d",j);
       m_gridSessions.SetTextMatrix(i,2,Temp0); 
	   Temp0.Format("%d",i);
       m_gridSessions.SetTextMatrix(i,0,Temp0); 	       
    }
	if(pchtemp[0]=='\0')
	{
		delete []pch;
		return NumbRecords;
    }
    delete []pch;
 return m_nAllLastSelectedScanNumber;
}
int PatientHistoryDial::CountNumberOfScans(const char* SessionDate)
{
CString Temp,Temp0,Temp1,Subsection;
	int ind=0,nAuto,nFilterInManualMode;
 	int countscans=0;
	char *pf;
    m_enTypeRegNode=encMeasureHistorySessionScansTypeRec;   
	CString Section=m_szPatient_Id;
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Node;
    Section+="\\";
	int NumbRecords=0,i,tablind=0;
	char* pch,*pchtemp;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return NumbRecords;
    int numbchar=YtvGetProfileSection(Section,NULL,0,1);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
	if(numbchar==0)
	{
		delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	int res;
	Temp0=SessionDate;
	Temp0.Replace('/','_');
	for(i=0;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
    {
       res=strcmp(pchtemp,Temp0);
       if(res==0)		   
         break;	       
    }
	if(pchtemp[0]=='\0')
	{
		delete []pch;
		return NumbRecords;
    }
	Section+=pchtemp;//current date
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Format[1];//scans directory
	Section+="\\";
	delete []pch;
	numbchar=YtvGetProfileSection(Section,NULL,0,1);
	if(numbchar==0)
		return NumbRecords;   
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
	if(numbchar==0)
	{
        delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	for(i=0;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
    {

		Subsection=Section+pchtemp;//scan number directory
		pf=m_arListReg[m_enTypeRegNode].Format[11];//manual auto vcr
		if(pf==NULL)
			   break;
		nAuto=YtvGetProfileInt(Subsection,pf,-3,1);
		if(nAuto<0)
			continue;	
		pf=m_arListReg[m_enTypeRegNode].Format[16];//filter
		if(pf==NULL)
			   break;   
        nFilterInManualMode=YtvGetProfileInt(Subsection,pf,-3,1);
		if(nFilterInManualMode<0)
			continue;
		countscans++;        
    }
	delete []pch;
	return countscans;
}
int PatientHistoryDial::ReadRegSession(const char* SessionDate)
{
	CString Temp,Temp0,Temp1,Subsection;
	int ind=0,nFilterInManualMode,nAuto;
 	char *pf;
//	EmptyGrids();
	EmptyLRGrids();
	m_nODLastSelectedScanNumber=0;
	m_nOSLastSelectedScanNumber=0;
	m_dTotalAL=0.0;
    m_enTypeRegNode=encMeasureHistorySessionScansTypeRec;   
	CString Section=m_szPatient_Id;
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Node;
    Section+="\\";
	int NumbRecords=0,i,tablind,tablindOD,tablindOS;
	tablindOD=tablindOS=tablind=0;
	char* pch,*pchtemp;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return NumbRecords;
    int numbchar=YtvGetProfileSection(Section,NULL,0,1);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
	if(numbchar==0)
	{
		delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	int res;
	Temp0=SessionDate;
	Temp0.Replace('/','_');
	for(i=0;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
    {
       res=strcmp(pchtemp,Temp0);
       if(res==0)		   
         break;	       
    }
	if(pchtemp[0]=='\0')
	{
		delete []pch;
		return NumbRecords;
    }
	Section+=pchtemp;//current date
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Format[1];//scans directory
	Section+="\\";
	delete []pch;
	numbchar=YtvGetProfileSection(Section,NULL,0,1);
	if(numbchar==0)
		return NumbRecords;
	pch=new char[numbchar+1];
	numbchar=YtvGetProfileSection(Section,pch,numbchar+1,1);
	if(numbchar==0)
	{
        delete []pch;
		return NumbRecords;
    }
	pchtemp=pch;
	for(i=0;pchtemp[0];i++, pchtemp+=strlen(pchtemp)+1)
    {
        Subsection=Section+pchtemp;//scan number directory
		//////////////////////////////////////////////////////
		pf=m_arListReg[m_enTypeRegNode].Format[4];
		if(pf==NULL)
			   break;
        ind=atoi(pchtemp);
		Temp=YtvGetProfileString(Subsection,pf,"",1);
		res=strcmp(Temp,"OD");//OD_OS selection
        if(res==0)
		{
			m_pgridSquares=&m_gridRightView;
            m_pgridMaAvSd=&m_gridHistoryRAverSd;
			m_arODScanIds.SetAtGrow(tablindOD+1,ind);
        }
		else if(res!=0)
		{
			m_pgridSquares=&m_gridLeftView;
            m_pgridMaAvSd=&m_gridHistoryLAverSd;
			m_arOSScanIds.SetAtGrow(tablindOS+1,ind);
        }       	
		if(ind>m_nGlobalSessionLastScanNumber)
		{
			m_uPrevScanNumber=m_nGlobalSessionLastScanNumber;
			m_nGlobalSessionLastScanNumber=ind;
        }
		///////////////////////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[14];
		if(pf==NULL)
			  break;
		m_nDBCurrentScanGroup=YtvGetProfileInt(Subsection,pf,-1,1); 
		if(m_nDBCurrentScanGroup>m_nGlobalScanGroup)
              m_nGlobalScanGroup=m_nDBCurrentScanGroup;
/*		if(m_nCurrentScanGroup<0)
        {
			m_nCurrentScanGroup=0;
			continue;
        }
		if(m_nCurrentScanGroup<m_nGlobalScanGroup)
		{
            m_nCurrentScanGroup=m_nGlobalScanGroup;
			m_strGroupScan.Format("%d",m_nCurrentScanGroup);
            m_strGroupScan.TrimLeft();
		}*/
		///////////////////////////////////////////////////////
		
		pf=m_arListReg[m_enTypeRegNode].Format[11];//manual auto vcr
		if(pf==NULL)
			   break;
		nAuto=YtvGetProfileInt(Subsection,pf,-3,1);
		if(nAuto<0)
			continue;	
		m_nAuto=nAuto;
		pf=m_arListReg[m_enTypeRegNode].Format[16];//filter
		if(pf==NULL)
			   break;   
        nFilterInManualMode=YtvGetProfileInt(Subsection,pf,-3,1);
		if(nFilterInManualMode<0)
			continue;
		m_bFilterNotInManualMode=nFilterInManualMode;
		pf=m_arListReg[m_enTypeRegNode].Format[6];
		if(pf==NULL)
			   break;
		m_nCataract=YtvGetProfileInt(Subsection,pf,0,1);
		pf=m_arListReg[m_enTypeRegNode].Format[5];
		if(pf==NULL)
			   break;
		m_nContact=YtvGetProfileInt(Subsection,pf,1,1);
		if(res==0)
		{
			tablindOD++;
			tablind=tablindOD;
        }
		else
        {
			tablindOS++;
            tablind=tablindOS;
		}
		if(m_nAuto==1)
        {
			if(m_bFilterNotInManualMode==FALSE) 
            {
			  m_pgridSquares->SetTextMatrix(tablind,1,"Manual");
			  m_pgridSquares->SetTextMatrix(tablind,2,"Distance");
            }
            if(m_bFilterNotInManualMode==TRUE) 
            {
                 if(m_nContact==0)
					m_pgridSquares->SetTextMatrix(tablind,1,"Cont");
				 else
                    m_pgridSquares->SetTextMatrix(tablind,1,"Immer"); 
				 if(m_nCataract==0)
					m_pgridSquares->SetTextMatrix(tablind,2,"Catar");
				 else
					m_pgridSquares->SetTextMatrix(tablind,2,"Aphak");
            }
        }
		else if(m_nAuto==0)
		{
			     if(m_nContact==0)
					m_pgridSquares->SetTextMatrix(tablind,1,"Cont");
				 else
                    m_pgridSquares->SetTextMatrix(tablind,1,"Immer"); 
				 if(m_nCataract==0)
					m_pgridSquares->SetTextMatrix(tablind,2,"Catar");
				 else
					m_pgridSquares->SetTextMatrix(tablind,2,"Aphak");
		}		
		////////////////////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[12];//data
		if(pf==NULL)
			   break;
		/////////////////////////////////////////	
		if(g_bShowDbScanId)
            m_pgridSquares->SetTextMatrix(tablind,0,pchtemp);
		else
        {
            Temp.Format("%d",tablind);
            m_pgridSquares->SetTextMatrix(tablind,0,Temp);
        }
		/////////////////////////////////////////////////////
	if(m_nAuto==1 && !m_bFilterNotInManualMode)
	{
		 pf=m_arListReg[m_enTypeRegNode].Format[13];
		if(pf==NULL)
			   break;
		Temp0=YtvGetProfileString(Subsection,pf,"-3",1);
		m_dDistance=atof(Temp0);
		if(m_dDistance<0.0)
          Temp0.Empty();
		if(Temp0.IsEmpty())
        {
			//continue;
        } 
	    m_pgridSquares->SetTextMatrix(tablind, 3, Temp0); //Dist manual mode
    }
	else if((m_nAuto==1 && m_bFilterNotInManualMode && m_nCataract==1) || (m_nAuto==0 && m_nCataract==1))
    {
        pf=m_arListReg[m_enTypeRegNode].Format[7];
		if(pf==NULL)
			   break;
		Temp0=YtvGetProfileString(Subsection,pf,"-3",1);
		m_dAL=atof(Temp0);
		if(m_dAL<0.0)
          Temp0.Empty();
		if(Temp0.IsEmpty())
        {
			//continue;
        } 
	    m_pgridSquares->SetTextMatrix(tablind, 3, Temp0); //AL Apha mode
	}
	else
	{
		pf=m_arListReg[m_enTypeRegNode].Format[7];
		if(pf==NULL)
			   break;	
		Temp=YtvGetProfileString(Subsection,pf,"",1);
		m_dAL=atof(Temp);
		if(m_dAL<=0.0)
		{
            m_dAL=0.0;
			//continue;
        }
        m_pgridSquares->SetTextMatrix(tablind, 3, Temp); //al       
		if(m_pgridSquares->GetCols()>4)
		{
			pf=m_arListReg[m_enTypeRegNode].Format[15];
		    if(pf==NULL)
			   break;
			Temp=YtvGetProfileString(Subsection,pf,"",1);
            //m_pgridSquares->SetTextMatrix(tablind, 2, Temp); //av
			pf=m_arListReg[m_enTypeRegNode].Format[8];
		    if(pf==NULL)
			   break;
			Temp=YtvGetProfileString(Subsection,pf,"",1);
            m_pgridSquares->SetTextMatrix(tablind, 4, Temp); //acd
            pf=m_arListReg[m_enTypeRegNode].Format[9];
		    if(pf==NULL)
			   break;
		    Temp=YtvGetProfileString(Subsection,pf,"",1);
            m_pgridSquares->SetTextMatrix(tablind, 5, Temp); //lt
            pf=m_arListReg[m_enTypeRegNode].Format[10];
		    if(pf==NULL)
			   break;
		    Temp=YtvGetProfileString(Subsection,pf,"",1);
            m_pgridSquares->SetTextMatrix(tablind, 6, Temp); //wit
		}
	
	}
	if(res==0)
	     m_nODLastSelectedScanNumber=tablind;
	else
		 m_nOSLastSelectedScanNumber=tablind;
//	{"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT",GlScanCount};
	   
    }
	delete []pch;

if(m_nODLastSelectedScanNumber>0)
{
    m_pgridSquares=&m_gridRightView;
    m_pgridMaAvSd=&m_gridHistoryRAverSd;
    CalculateAvSd(m_nODLastSelectedScanNumber);
	m_gridRightView.SetRowSel(0);
}
if(m_nOSLastSelectedScanNumber>0)
{
    m_pgridSquares=&m_gridLeftView;
    m_pgridMaAvSd=&m_gridHistoryLAverSd;
    CalculateAvSd(m_nOSLastSelectedScanNumber);
    m_gridLeftView.SetRowSel(0);
}
 UpdateData(FALSE);
 m_nAllLastSelectedScanNumber=m_nODLastSelectedScanNumber+m_nOSLastSelectedScanNumber;
 return m_nAllLastSelectedScanNumber;
}
void PatientHistoryDial::EmptyLRGrids()
{
    int rows=m_gridLeftView.GetRows(),r;
	int cols=m_gridLeftView.GetCols(),c;
	for(r=1;r<rows; r++)
		for(c=0;c<cols;c++)
            m_gridLeftView.SetTextMatrix(r,c,"");
    rows=m_gridRightView.GetRows();
	cols=m_gridRightView.GetCols();
	for(r=1;r<rows; r++)
		for(c=0;c<cols;c++)
            m_gridRightView.SetTextMatrix(r,c,"");
    rows=m_gridHistoryLAverSd.GetRows();
	cols=m_gridHistoryLAverSd.GetCols();
	for(r=0;r<rows; r++)
		for(c=1;c<cols;c++)
            m_gridHistoryLAverSd.SetTextMatrix(r,c,"");
    rows=m_gridHistoryRAverSd.GetRows();
	cols=m_gridHistoryRAverSd.GetCols();
	for(r=0;r<rows; r++)
		for(c=1;c<cols;c++)
            m_gridHistoryRAverSd.SetTextMatrix(r,c,"");
}
void PatientHistoryDial::CalculateAvSd(int GLine)
{

 CString Temp;
 double dtemp;
 int ntemp,i;
m_dTotalAL=0.0;
if(GLine<1)
   GLine=1;
 for(i=1;i<=GLine;i++)
 {
   Temp=m_pgridSquares->GetTextMatrix(i,3);
   Temp.TrimLeft();
   dtemp=atof(Temp);
   m_dTotalAL+=dtemp;
 } 
 ntemp=(int)((m_dTotalAL/(double)GLine)*100.0);
 double Av=((double)ntemp)/100.0;
 Temp.Format("%9.2f",Av);
 Temp.TrimLeft();
 m_pgridMaAvSd->SetTextMatrix(0, 1, Temp); 
 m_dALSD=0.0;
 for(i=1;i<=GLine;i++)
 {
   Temp=m_pgridSquares->GetTextMatrix(i,3);
   Temp.TrimLeft();
   dtemp=atof(Temp);
   m_dALSD+=(dtemp-Av)*(dtemp-Av);
 }
 if(GLine<=1)
         m_dALSD=0.0;
 else
         m_dALSD/=(GLine-1);
 if(m_dALSD<=0.0)
 {
	 m_dALSD=0.0;
     Temp="0";
 }
 else
 {
	 m_dALSD=sqrt(m_dALSD); 
     Temp.Format("%5.2f",m_dALSD); 
 }
 Temp.TrimLeft();
 m_pgridMaAvSd->SetTextMatrix(1, 1, Temp); 
// m_strMuxCadrNum.Format("%d",m_nGlobalSessionLastScanNumber);
// m_edMaxCadrNum.SetWindowText(m_strMuxCadrNum); 
/////////////////////////////////////////////////////
}
void PatientHistoryDial::CalculateAvCommon(int GLine)
{
	CString Temp;
m_szAvAl=m_pgridSquares->GetTextMatrix(GLine, 3);  
if(m_szAvAl.IsEmpty())
   m_szAvAl="0.00";
m_szAvAl+=" mm"; 
m_stAvAL.SetWindowText(m_szAvAl);
m_stAvAL.Invalidate();
///////////////////////////////////
Temp=m_pgridSquares->GetTextMatrix(GLine, 4);   
 m_gridHistoryAlAcdLtVit.SetTextMatrix(1, 1,Temp);
 m_dACD=atof(Temp);//"ACD @ 1555m/sec");
Temp=m_pgridSquares->GetTextMatrix(GLine, 5);   
 m_gridHistoryAlAcdLtVit.SetTextMatrix(2, 1,Temp);
 m_dLT=atof(Temp);//"LT @ 1551m/sec");
Temp=m_pgridSquares->GetTextMatrix(GLine, 6);
 m_gridHistoryAlAcdLtVit.SetTextMatrix(3, 1, Temp);
 m_dVIT=atof(Temp);
 Temp.Format("%6.2f",m_dACD+m_dLT+m_dVIT);
 Temp.TrimLeft();
 m_gridHistoryAlAcdLtVit.SetTextMatrix(0, 1, Temp);
}

BEGIN_EVENTSINK_MAP(PatientHistoryDial, CDialog)
    //{{AFX_EVENTSINK_MAP(PatientHistoryDial)
	ON_EVENT(PatientHistoryDial, IDC_GRID_LEFTHISTORY, -600 /* Click */, OnClickGridLefthistory, VTS_NONE)
	ON_EVENT(PatientHistoryDial, IDC_GRIDRIGHTHISTORY, -600 /* Click */, OnClickGridrighthistory, VTS_NONE)
	ON_EVENT(PatientHistoryDial, IDC_GRID_SESSIONS, -600 /* Click */, OnClickGridSessions, VTS_NONE)
	ON_EVENT(PatientHistoryDial, IDC_GRID_SESSIONS, 69 /* SelChange */, OnSelChangeGridSessions, VTS_NONE)
	ON_EVENT(PatientHistoryDial, IDC_GRID_LEFTHISTORY, 70 /* RowColChange */, OnRowColChangeGridLefthistory, VTS_NONE)
	ON_EVENT(PatientHistoryDial, IDC_GRIDRIGHTHISTORY, 70 /* RowColChange */, OnRowColChangeGridrighthistory, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void PatientHistoryDial::OnClickGridLefthistory() 
{
	// TODO: Add your control notification handler code here
   
}

void PatientHistoryDial::OnClickGridrighthistory() 
{
	// TODO: Add your control notification handler code here
   	
}

void PatientHistoryDial::OnClickGridSessions() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL PatientHistoryDial::Create(CWnd* pParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_pdb=(DataBasePage*)pParentWnd;
	return CDialog::Create(IDD, pParentWnd);
}
void PatientHistoryDial::OnCancel() 
{
    OnOK(); 
}
void PatientHistoryDial::OnOK() 
{
	// TODO: Add extra validation here
	YtvSetAdditionalRegNode(m_pdb->m_strAddionalRegistryOld);
	if(m_pdb)
	{
		m_pdb->ReadRegistryDB();
	    m_pdb->UpdateData(FALSE);
    }
	m_arODScanIds.RemoveAll();
	m_arOSScanIds.RemoveAll();
	CWnd::DestroyWindow();
    delete this;
	//CDialog::OnOK();
}
void PatientHistoryDial::OnSelChangeGridSessions() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int row=m_gridSessions.GetRowSel();
	if(row<1)
		return;
	m_strSesDate=m_gridSessions.GetTextMatrix(row,1);
    m_strSesDate.TrimLeft();
	if(m_strSesDate.IsEmpty())
		return;
    ReadRegSession(m_strSesDate);
    m_gridLeftView.SetRow(0);
	m_gridLeftView.SetRowSel(0);
	m_gridRightView.SetRow(0);
	m_gridRightView.SetRowSel(0);
	UpdateData(FALSE);
}

void PatientHistoryDial::OnRowColChangeGridLefthistory() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	long sr=m_gridLeftView.GetRowSel();
	if(sr<1)
		return;
    m_strFc=m_gridLeftView.GetTextMatrix(sr,0);
	if(m_strFc.IsEmpty())
	{
        m_gridLeftView.SetRow(0);
		m_gridLeftView.SetRowSel(0);
		return;
    }
	m_nPrevScanNumber=m_nCurrentScan;
    m_nCurrentScan=m_nNextScan=atoi(m_strFc);
	m_bDisplay=TRUE;
	m_pgridSquares=&m_gridLeftView;
	m_pgridMaAvSd=&m_gridHistoryLAverSd;
	CalculateAvCommon(sr);
	unsigned int uScanDbId=m_arOSScanIds.GetAt(sr);
    m_strFc.Format("%06u",uScanDbId);
    PlayScan(m_strSesDate,m_strFc);	
	m_bDisplay=FALSE;
	m_gridRightView.SetRow(0);
	m_gridRightView.SetRowSel(0);
	UpdateData(FALSE);
}

void PatientHistoryDial::OnRowColChangeGridrighthistory() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	long sr=m_gridRightView.GetRowSel();
	if(sr<1)
		return;
    m_strFc=m_gridRightView.GetTextMatrix(sr,0);
	if(m_strFc.IsEmpty())
	{
		m_gridRightView.SetRow(0);
		m_gridRightView.SetRowSel(0);
		return;
    }
	m_nPrevScanNumber=m_nCurrentScan;
    m_nCurrentScan=m_nNextScan=atoi(m_strFc);
	m_bDisplay=TRUE;
	m_pgridSquares=&m_gridRightView;
    m_pgridMaAvSd=&m_gridHistoryRAverSd;
	CalculateAvCommon(sr);
	unsigned int uScanDbId=m_arODScanIds.GetAt(sr);
    m_strFc.Format("%06u",uScanDbId);
    PlayScan(m_strSesDate,m_strFc);	
	m_bDisplay=FALSE;
	m_gridLeftView.SetRow(0);
	m_gridLeftView.SetRowSel(0);
	UpdateData(FALSE);
}
void PatientHistoryDial::PlayScan(const char* SesDate,const char* ScanNum)
{
	UpdateData();
   // m_strSlideCount.Format("%d",m_nNextScan);
    //m_edSlideCount.SetWindowText(m_strSlideCount);
CString Temp0,Temp1;
	char *pf;
	const unsigned char *pd;
	int NumbRecords=0;
    m_enTypeRegNode=encMeasureHistorySessionScansTypeRec;   
	CString Section=m_szPatient_Id;
	Section+="\\";
	Section+=m_arListReg[m_enTypeRegNode].Node;
    Section+="\\";
	Temp0=SesDate;
	Temp0.Replace('/','_');
	Section+=Temp0;
    if(m_arListReg[m_enTypeRegNode].Format==NULL)
		return;
    Section+="\\";
	CString Subsection;
    Section+=m_arListReg[m_enTypeRegNode].Format[1];//scans directory
   	Section+="\\";
	CString Temp;
	int Group;
		Temp=ScanNum;
       	Subsection=Section+Temp;//scan number directory
		/////////////////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[14];
		if(pf==NULL)
			  return;
		Group=YtvGetProfileInt(Subsection,pf,-1,1); 
		m_nCurrentScanGroup=atoi(m_strGroupScan);
		////////////////////////////////////////////
       	///////////////////////////????????????
	  	/////////////////////////////////////////////////////
	    pf=m_arListReg[m_enTypeRegNode].Format[12];
		if(pf==NULL)
			  return;
		pd=YtvGetProfileBinary(Subsection,pf,NULL,&m_nMemorySize,1);
	    if(!pd)
		{
			m_nMemorySize=1024;
			return ;
        }
		memcpy((void *)m_npDataBuf,(void *)pd,m_nMemorySize);
        m_nMemorySize=1024;
			//////////////////////////////////////
        pf=m_arListReg[m_enTypeRegNode].Format[17];
		if(pf==NULL)
			  return;
		m_curThr.Pics[encCorniaThreshHold]=YtvGetProfileInt(Subsection,pf,-5,1);
	    pf=m_arListReg[m_enTypeRegNode].Format[20];
		if(pf==NULL)
			  return;
		m_curThr.Pics[encRetinaThreshHold]=YtvGetProfileInt(Subsection,pf,-5,1);
		pf=m_arListReg[m_enTypeRegNode].Format[18];
		if(pf==NULL)
			  return;
		m_curThr.Pics[encLensThreshHoldBegin]=YtvGetProfileInt(Subsection,pf,-5,1);
		pf=m_arListReg[m_enTypeRegNode].Format[19];
		if(pf==NULL)
			  return;
		m_curThr.Pics[encLensThreshHoldEnd]=YtvGetProfileInt(Subsection,pf,-5,1);
		memcpy(m_NumbPics,m_curThr.Pics,sizeof(m_NumbPics));
		//	{"SessionDate","InScans","ScanNumber","InScanValues","InOD_OS","InMethod","InMode","OutAL","OutACD","OutLT","OutVIT","ScData"};
	   /////////////////////////////////////////////////////////
    	pf=m_arListReg[m_enTypeRegNode].Format[11];//manual auto vcr
		if(pf==NULL)
			   return;
		m_nAuto=YtvGetProfileInt(Subsection,pf,-3,1);
		/////////////////
		pf=m_arListReg[m_enTypeRegNode].Format[16];//filter
		if(pf==NULL)
			   return;   
        m_bFilterNotInManualMode=YtvGetProfileInt(Subsection,pf,-1,1);
		//////////////////////////////////////////
		pf=m_arListReg[m_enTypeRegNode].Format[6];
		if(pf==NULL)
			   return;
		m_nCataract=YtvGetProfileInt(Subsection,pf,0,1);
		/////////////////////////////////////////////
		pf=m_arListReg[m_enTypeRegNode].Format[5];
		if(pf==NULL)
			   return;
		m_nContact=YtvGetProfileInt(Subsection,pf,1,1);
		/////////////////////////////////////////////
        SetSpeeds();
 UpdateData(FALSE);
 DisplayGraph();
}
void PatientHistoryDial::DrawMarks(unsigned int MakeSound)
{
RECT rt;
int i,j;
short pX[17], pY[17], pType[17];
m_imHistoryGraph.GetClientRect(&rt);
i=0;
for(j=0;j<4;j++)
{
  if(m_NumbPics[j]>=0)
  {
    ++i;
	pX[i]=m_imHistoryGraph.PixelFromDataXCoor(m_NumbPics[j])-g_nHorMarkLen;
	if(pX[i]<0)
		pX[i]=0;
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
    pY[i]=g_nHorLineY;
	pType[i]=0;
	///////////////////////////////////
	++i;
	pX[i]=m_imHistoryGraph.PixelFromDataXCoor(m_NumbPics[j])+g_nHorMarkLen;
    if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY;
	pType[i]=1;
	////////////////////////////////
	++i;
    pX[i]=(short)m_imHistoryGraph.PixelFromDataXCoor(m_NumbPics[j]);
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY+g_nVerMarkLen;
	pType[i]=0;
	/////////////////////////////////
	++i;
	pX[i]=(short)m_imHistoryGraph.PixelFromDataXCoor(m_NumbPics[j]);
	if(pX[i]>rt.right)
		pX[i]=(short)rt.right;
	if(pX[i]<0)
		pX[i]=0;
    pY[i]=g_nHorLineY-g_nVerMarkLen;
	pType[i]=1;
  }
  //m_NumbPics[j]=-1;

}
  if(i>0)
  {
	  m_imHistoryGraph.SetDrawLines(pX, pY, pType, i+1);
	  if(MakeSound)
	         MessageBeep(MB_ICONEXCLAMATION);
  }
  else
	m_imHistoryGraph.SetDrawLines(NULL, NULL, NULL, 0);
  m_imHistoryGraph.Invalidate(FALSE);
}
void PatientHistoryDial::SetSpeeds()
{
	CString Temp;
if(m_nAuto<=0 || (m_nAuto==1 && m_bFilterNotInManualMode))
  {
	m_strFormat="AL @ Ave. Velocity %d m/sec";
    if(m_nContact==0 && m_nCataract==1)
    {//no lens 0.5 lens
		g_dCurrentScaleLength=39.0;
		g_nCurrentSpeed=1532;
		Temp.Format(m_strFormat,g_nCurrentSpeed);
	   	m_stAvelo.SetWindowText(Temp);
        m_stAvelo.Invalidate();	    
	}
	else if(m_nContact==0 && m_nCataract==0)
    {		
		g_dCurrentScaleLength=39.5;
		g_nCurrentSpeed=1555;
		Temp.Format(m_strFormat,g_nCurrentSpeed);
	   	m_stAvelo.SetWindowText(Temp);
        m_stAvelo.Invalidate();
    }
	else if(m_nContact==1 && m_nCataract==1)
    {//nolens		
		g_dCurrentScaleLength=39.0;
        g_nCurrentSpeed=1532;
		Temp.Format(m_strFormat,g_nCurrentSpeed);
	    m_stAvelo.SetWindowText(Temp);
        m_stAvelo.Invalidate();	   
		
	}else if(m_nContact==1 && m_nCataract==0)
    {
		g_dCurrentScaleLength=39.5;
        g_nCurrentSpeed=1555;
		Temp.Format(m_strFormat,g_nCurrentSpeed);
	   	m_stAvelo.SetWindowText(Temp);
        m_stAvelo.Invalidate();
	}
	
  }
  else if(m_nAuto==1 && m_bFilterNotInManualMode==FALSE)
  {
   
	g_dCurrentScaleLength=39.5;
    m_strFormat="Distance Vel. %d mm/sec";
	g_nCurrentSpeed=1550;
	Temp.Format(m_strFormat,g_nCurrentSpeed);
	m_stAvelo.SetWindowText(Temp);
    m_stAvelo.Invalidate();
  } 
}
