// YtvEmailDial.cpp : implementation file
//

#include "stdafx.h"
#include "YtvEmailDial.h"
#include "YtvScansDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// YtvEmailDial dialog


YtvEmailDial::YtvEmailDial(CWnd* pParent /*=NULL*/)
	: CDialog(YtvEmailDial::IDD, pParent)
{
	
}

YtvEmailDial::YtvEmailDial()
	: CDialog()
{
	//{{AFX_DATA_INIT(YtvEmailDial)
	m_szEmail = _T("");
	m_strEMessage = _T("");
	//}}AFX_DATA_INIT
}

void YtvEmailDial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(YtvEmailDial)
	DDX_Text(pDX, IDC_EDIT_EMAIL, m_szEmail);
	DDX_Text(pDX, IDC_EDIT_EMAIL_MESSAGE, m_strEMessage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(YtvEmailDial, CDialog)
	//{{AFX_MSG_MAP(YtvEmailDial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// YtvEmailDial message handlers

BOOL YtvEmailDial::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ShowWindow(SW_MAXIMIZE);
	// TODO: Add extra initialization here
	CString t="Send data of ";
	t+=m_szInpOutCaption+" by E-Mail";
    SetWindowText(t);
	m_szPath=YtvGetAdditionalRegNode();
	m_szPath+='\\';
	m_szPath+=m_szId+'\\';

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void YtvEmailDial::OnOK() 
{
	CWinApp* pApp=AfxGetApp();
	POSITION pos=pApp->GetFirstDocTemplatePosition();
    m_pDocTemplate=pApp->GetNextDocTemplate(pos);
    pos=m_pDocTemplate->GetFirstDocPosition();
	m_pDoc=NULL;
	while(pos)
    {
        m_pDoc=m_pDocTemplate->GetNextDoc(pos);
        if(!m_pDoc)
			continue;
		((CYtvScansDoc*)m_pDoc)->m_bMail=TRUE;
		if(m_szId.IsEmpty())
        {
			m_pDoc->SetPathName(m_szId,FALSE);
			break;
        } 
		else
		{
			m_pDoc->SetPathName(m_szId+'\\', FALSE);
			break;
		}
	}   
	DestroyWindow();
	delete this;
	//CDialog::OnOK();
}

BOOL YtvEmailDial::Create(HWND hParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::Create(IDD, CWnd::FromHandle(hParentWnd));
}

void YtvEmailDial::OnCancel() 
{
	// TODO: Add extra cleanup here
	DestroyWindow();
	delete this;
//	CDialog::OnCancel();
}
